Package: RSVSim
Type: Package
Title: RSVSim: an R/Bioconductor package for the simulation of
        structural variations
Version: 1.53.0
Date: 2024-04-23
Author: Christoph Bartenhagen
Maintainer: Christoph Bartenhagen
 <c.bartenhagen@uni-koeln.de>
Imports: methods, IRanges, ShortRead
Depends: R (>= 3.5.0), Biostrings, GenomicRanges
Suggests: BSgenome.Hsapiens.UCSC.hg19,
        BSgenome.Hsapiens.UCSC.hg19.masked, MASS, rtracklayer, pwalign
Description: RSVSim is a package for the simulation of deletions,
        insertions, inversion, tandem-duplications and translocations
        of various sizes in any genome available as FASTA-file or
        BSgenome data package. SV breakpoints can be placed uniformly
        accross the whole genome, with a bias towards repeat regions
        and regions of high homology (for hg19) or at user-supplied
        coordinates.
License: LGPL-3
biocViews: Sequencing
git_url: https://git.bioconductor.org/packages/RSVSim
git_branch: devel
git_last_commit: 9485f7c
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:47:38 UTC; biocbuild

setMethod("estimateSVSizes",
          signature(n="numeric", svSizes="missing", default="character"),
          function(n, svSizes, minSize, maxSize, default, hist){
            if(!(default %in% c("deletions", "insertions", "inversions", "tandemDuplications"))){
              stop("Invalid argument: No default values for SV type ", default)
            }
            ## Default shape parameters were estimated from DGV release 2012-03-29
            ## Only studies with "method=sequencing" and size between 500bp and 10kb were selected (for insertions the extreme peak between 6000bp and 6200bp has been removed)
            ## SVs left: 1129 Deletions, 490 Insertions, 202 Inversions, 145 Tandem Duplications
            if(default == "deletions"){
              shape1=0.3692374
              shape2=2.689951
            }
            if(default == "insertions"){
              shape1=0.7106429
              shape2=2.274061
            }
            if(default == "inversions"){
              shape1=0.5786958
              shape2=1.83066
            }
            if(default == "tandemDuplications"){
              shape1=0.4084596
              shape2=1.998082
            }
            if(any(is.na(c(minSize, maxSize)))){
              return(.getSVSizes(n=n, shape1=shape1, shape2=shape2, min=500, max=10000, hist=hist))
            }else{
              return(.getSVSizes(n=n, shape1=shape1, shape2=shape2, min=minSize, max=maxSize, hist=hist))
            }
          })

setMethod("estimateSVSizes",
          signature(n="numeric", svSizes="missing", default="missing"),
          function(n, svSizes, minSize, maxSize, default, hist){
            stop("Missing argument(s): Please give either a set of SVs or choose a set of default values.")
          })

setMethod("estimateSVSizes",
          signature(n="numeric", svSizes="numeric", default="missing"),
          function(n, svSizes, minSize, maxSize, default, hist){

            require(MASS)
            
            ## calculate the two shape parameters from given set of SVs
            min = min(svSizes)
            max = max(svSizes)            

            svSizes = (svSizes-min)/(max-min+1)

            ## make sure values are >0 and <1
            svSizes[svSizes == 0] = svSizes[svSizes == 0] + 1e-5
            svSizes[svSizes == 1] = svSizes[svSizes == 1] - 1e-5

#            m = mean(svSizes)
#            m = (m-min)/(max-min)
#            v = var(svSizes)
#            v = v/(max-min)^2
            
            ## shape parameters for beta distribution
#            shape1 = m*(((m*(1-m))/v)-1)
#            shape2 = (1-m)*(((m*(1-m))/v)-1)
            
            beta = suppressWarnings(fitdistr(svSizes, "beta", start=list(shape1=0.1, shape2=0.1)))
            shape1 = beta$estimate[1]
            shape2 = beta$estimate[2]
            
            if(any(c(is.na(minSize), is.na(maxSize)))){
              return(.getSVSizes(n=n, shape1=shape1, shape2=shape2, min=min, max=max, hist=hist))
            }else{
              return(.getSVSizes(n=n, shape1=shape1, shape2=shape2, min=minSize, max=maxSize, hist=hist))
            }
          })

.getSVSizes <- function(n, shape1, shape2, min, max, hist){

  simSizes = rbeta(n, shape1=shape1, shape2=shape2)
  simSizes = round((simSizes*(max-min+1))+min)
  if(hist == TRUE){
    hist(simSizes)
  }
  return(simSizes)
  
}

setMethod("compareSV",
          signature("data.frame", "data.frame"),
          function(querySVs, simSVs, tol){
            simSVs_overlap = .compareSV(querySVs, simSVs, tol)
            return(simSVs_overlap)
          })

setMethod("compareSV",
          signature("character", "data.frame"),
          function(querySVs, simSVs, tol){
            querySVs= read.table(querySVs, sep="\t", header=FALSE, stringsAsFactors=FALSE, fill=TRUE)
            simSVs_overlap = .compareSV(querySVs, simSVs, tol)
            return(simSVs_overlap)
          })

setMethod("compareSV",
          signature("character", "character"),
          function(querySVs, simSVs, tol){
            simSVs = read.table(simSVs, fill=TRUE, header=TRUE)
            querySVs= read.table(querySVs, sep="\t", header=FALSE, stringsAsFactors=FALSE, fill=TRUE)
            simSVs_overlap = .compareSV(querySVs, simSVs, tol)
            return(simSVs_overlap)
          })

## deletions: (1) BED with colums chr,start,end(,bpSeq) or (2) BEDPE with colums chr,start1,end1,chr,start2,end2(,bpSeq)
## insertions: BEDPE with columns chrA,startA,endA, chrB,startB,endB(, bpSeq); two rows for one SV (5' and 3' breakpoint respectively)
## inversions: (1) BED with colums chr,start,end(,bpSeq1, bpSeq2) or (2) BEDPE with colums chr,start1,end1,chr,start2,end2(,bpSeq1, bpSeq2)
## tandem duplications: (1) BED with colums chr,start,end or (2) BEDPE with colums chr,start1,end1,chr,start2,end2
## translocations: BEDPE with columns chrA,startA,endA, chrB,startB,endB, (bpSeq1, bpSeq2)
.compareSV <- function(querySVs, simSVs, tol){
  ## Might call .getOverlap() which requires the pwalign package.
  if (!requireNamespace("pwalign", quietly=TRUE))
    stop("Could not load package pwalign. Is it installed?\n\n  ",
         wmsg("Note that compareSV() requires the pwalign package. ",
              "Please install it with:"),
         "\n\n    BiocManager::install(\"pwalign\")")
  ## get the type of SV by checking the column names in simSVs
  type = NA
  if(all(c("Name", "Chr", "Start", "End", "Size",  "BpSeq") %in% colnames(simSVs))){
    type = "deletion"
  }
  if(all(c("Name", "Chr", "Start", "End", "Size", "BpSeq_5prime", "BpSeq_3prime") %in% colnames(simSVs))){
    type = "inversion"
  }
  if(all(c("Name", "ChrA", "StartA", "EndA", "ChrB", "StartB", "EndB", "Size", "Copied", "BpSeqA", "BpSeqB_5prime", "BpSeqB_3prime") %in% colnames(simSVs))){
    type = "insertion"
  }
  if(all(c("Name", "Chr", "Start", "End", "Size", "Duplications", "BpSeq") %in% colnames(simSVs))){
    type = "tandemDuplication"
  }
  if(all(c("Name", "ChrA", "StartA", "EndA", "SizeA", "ChrB", "StartB", "EndB", "SizeB", "Balanced", "BpSeqA", "BpSeqB") %in% colnames(simSVs))){
    type = "translocation"
  }
  if(is.na(type)){
    stop("Invalid input: Format of the second set of SVs differs from the output format of the simulator.")
  }
  
  ## load user-supplied set of svs (BED- or BEDPE-file)
  querySVs_Bp1 = querySVs_Bp1 = NULL
  ## split BED input into appropriate GRanges objects, which depends on the number of given columns (BED or BEDPE, with or without bpSeq)
  ## give every SV an id to remember which breakpoints belong together after GRanges sorted the coordinates
  ## inversions
  if(ncol(querySVs) == 8){
    querySVs_Bp1 = GRanges(IRanges(querySVs[, 2], querySVs[, 3]), seqnames=querySVs[, 1], bpSeq1=querySVs[, 7], bpSeq2=querySVs[, 8], id=1:nrow(querySVs))
    querySVs_Bp2 = GRanges(IRanges(querySVs[, 5], querySVs[, 6]), seqnames=querySVs[, 4], bpSeq1=querySVs[, 7], bpSeq2=querySVs[, 8], id=1:nrow(querySVs))
  }
  ## translocations, insertions or deletions
  if(ncol(querySVs) == 7){
    querySVs_Bp1 = GRanges(IRanges(querySVs[, 2], querySVs[, 3]), seqnames=querySVs[, 1], bpSeq=querySVs[, 7], id=1:nrow(querySVs))
    querySVs_Bp2 = GRanges(IRanges(querySVs[, 5], querySVs[, 6]), seqnames=querySVs[, 4], bpSeq=querySVs[, 7], id=1:nrow(querySVs))
  }
  ## translocations, inversions, insertions or deletions (no bpSeq)
  if(ncol(querySVs) == 6){
    querySVs_Bp1 = GRanges(IRanges(querySVs[, 2], querySVs[, 3]), seqnames=querySVs[, 1], bpSeq=NA, bpSeq2=NA, id=1:nrow(querySVs))
    querySVs_Bp2 = GRanges(IRanges(querySVs[, 5], querySVs[, 6]), seqnames=querySVs[, 4], bpSeq=NA, bpSeq2=NA, id=1:nrow(querySVs))
  }
  ## inversions
  if(ncol(querySVs) == 5){
    querySVs_Bp1 = GRanges(IRanges(querySVs[, 2], querySVs[, 2]), seqnames=querySVs[, 1], bpSeq1=querySVs[, 4], bpSeq2=querySVs[, 5], id=1:nrow(querySVs))
    querySVs_Bp2 = GRanges(IRanges(querySVs[, 3], querySVs[, 3]), seqnames=querySVs[, 1], bpSeq1=querySVs[, 4], bpSeq2=querySVs[, 5], id=1:nrow(querySVs))
  }
  ## deletions
  if(ncol(querySVs) == 4){
    querySVs_Bp1 = GRanges(IRanges(querySVs[, 2], querySVs[, 2]), seqnames=querySVs[, 1], bpSeq=querySVs[, 4], id=1:nrow(querySVs))
    querySVs_Bp2 = GRanges(IRanges(querySVs[, 3], querySVs[, 3]), seqnames=querySVs[, 1], bpSeq=querySVs[, 4], id=1:nrow(querySVs))
  }
  ## deletions, inversions (no bpSeq)
  if(ncol(querySVs) == 3){
    querySVs_Bp1 = GRanges(IRanges(querySVs[, 2], querySVs[, 2]), seqnames = querySVs[, 1], bpSeq=NA, bpSeq1=NA, bpSeq2=NA, id=1:nrow(querySVs))
    querySVs_Bp2 = GRanges(IRanges(querySVs[, 3], querySVs[, 3]), seqnames = querySVs[, 1], bpSeq=NA, bpSeq1=NA, bpSeq2=NA, id=1:nrow(querySVs))
  }
  if(all(is.null(querySVs_Bp1), is.null(querySVs_Bp2))){
    stop("Invalid SV file: Please make sure, that the SV file is in BED (chr,start,end) or BEDPE format (chr1,start1,end1,chr2,start2,end2) and contains only the breakpoint sequence(s) as additional column")
  }
  numOverlaps = 0
  
  ## For deletions and tandem duplications compare the 1 breakpoint and the 1 breakpoint sequence
  if(type == "deletion" | type == "tandemDuplication"){
    simSVs$Overlap = ""
    simSVs$OverlapBpSeq = NA
    for(v in 1:nrow(simSVs)){
      simSV = simSVs[v, ]
      ## check correct start and end coordinate
      chr = as.character(simSV$Chr)
      simSV_Bp1 = GRanges(IRanges(simSV$Start, simSV$Start), seqnames=chr)
      simSV_Bp2 = GRanges(IRanges(simSV$End, simSV$End), seqnames=chr)
      overlap = .getOverlap(list(simSV_Bp1, simSV_Bp2), list(querySVs_Bp1[seqnames(querySVs_Bp1) == chr], querySVs_Bp2[seqnames(querySVs_Bp2) == chr]), list(simSV$BpSeq, querySVs_Bp1[seqnames(querySVs_Bp1) == chr]$bpSeq), list(NA, NA), tol, type)
      if(!is.null(overlap)){
        simSVs$Overlap[v] = overlap[[1]]
        simSVs$OverlapBpSeq[v] = overlap[[2]]
        numOverlaps = numOverlaps + overlap[[4]]
      }
    }
  }
  ## For inversions compare the 1 breakpoint and the 2 breakpoint sequences
  ## seq|invseq|seq
  if(type == "inversion"){
    simSVs$Overlap = ""
    simSVs$OverlapBpSeq_5prime = NA
    simSVs$OverlapBpSeq_3prime = NA
    for(v in 1:nrow(simSVs)){
      simSV = simSVs[v, ]
      ## check correct start and end coordinate
      chr = as.character(simSV$Chr)
      simSV_Bp1 = GRanges(IRanges(simSV$Start, simSV$Start), seqnames=chr)
      simSV_Bp2 = GRanges(IRanges(simSV$End, simSV$End), seqnames=chr)
      overlap = .getOverlap(list(simSV_Bp1, simSV_Bp2), list(querySVs_Bp1[seqnames(querySVs_Bp1) == chr], querySVs_Bp2[seqnames(querySVs_Bp2) == chr]), list(simSV$BpSeq_5prime, querySVs_Bp1[seqnames(querySVs_Bp1) == chr]$bpSeq1), list(simSV$BpSeq_3prime, querySVs_Bp1[seqnames(querySVs_Bp1) == chr]$bpSeq2), tol, type)
      if(!is.null(overlap)){
        simSVs$Overlap[v] = overlap[[1]]
        simSVs$OverlapBpSeq_5prime[v] = overlap[[2]]
        simSVs$OverlapBpSeq_3prime[v] = overlap[[3]]
        numOverlaps = numOverlaps + overlap[[4]]
      }
    }
  }
  ## For insertions compare the 2 breakpoints and 2 breakpoint sequences
  ## chrB|chrA|chrB
  if(type == "insertion"){
    simSVs$Overlap_5prime = ""
    simSVs$Overlap_3prime = ""
    simSVs$OverlapBpSeq_5prime = NA
    simSVs$OverlapBpSeq_3prime = NA
    for(v in 1:nrow(simSVs)){
      simSV = simSVs[v, ]
      ## Compare breakpoint at chrB|chrA (5', i.e. start)
      simSV_Bp1 = GRanges(IRanges(simSV$StartB, simSV$StartB), seqnames=simSV$ChrB)
      simSV_Bp2 = GRanges(IRanges(simSV$StartA, simSV$StartA), seqnames=simSV$ChrA)
      chr1 = as.character(seqnames(simSV_Bp1))
      chr2 = as.character(seqnames(simSV_Bp2))
      querySVs_Bp12 = c(querySVs_Bp1, querySVs_Bp2)
      overlap = .getOverlap(list(simSV_Bp1, simSV_Bp2), list(querySVs_Bp12[seqnames(querySVs_Bp12) == chr1], querySVs_Bp12[seqnames(querySVs_Bp12) == chr2]), list(simSV$BpSeqB_5prime, querySVs_Bp12[seqnames(querySVs_Bp12) == chr1]$bpSeq), list(NA, NA), tol, type)
      if(!is.null(overlap)){
        simSVs$Overlap_5prime[v] = overlap[[1]]
        simSVs$OverlapBpSeq_5prime[v] = overlap[[2]]
        numOverlaps = numOverlaps + overlap[[4]]
      }
      ## Compare second breakpoint at chrA|chrB (3', i.e. end)
      simSV_Bp1 = GRanges(IRanges(simSV$EndA, simSV$EndA), seqnames=simSV$ChrA)
      simSV_Bp2 = GRanges(IRanges(simSV$StartB, simSV$StartB), seqnames=simSV$ChrB)
      chr1 = as.character(seqnames(simSV_Bp1))
      chr2 = as.character(seqnames(simSV_Bp2))
      overlap = .getOverlap(list(simSV_Bp1, simSV_Bp2), list(querySVs_Bp12[seqnames(querySVs_Bp12) == chr1], querySVs_Bp12[seqnames(querySVs_Bp12) == chr2]), list(simSV$BpSeqB_3prime, querySVs_Bp12[seqnames(querySVs_Bp12) == chr1]$bpSeq), list(NA, NA), tol, type)
      if(!is.null(overlap)){
        simSVs$Overlap_3prime[v] = overlap[[1]]
        simSVs$OverlapBpSeq_3prime[v] = overlap[[2]]
        numOverlaps = numOverlaps + overlap[[4]]
      }
      
    }
  }
  ## For translocations compare the 2 breakpoints and 1 breakpoint sequence
  if(type == "translocation"){
    simSVs$Overlap = ""
    simSVs$OverlapBpSeq_A = NA
    simSVs$OverlapBpSeq_B = NA
    for(v in 1:nrow(simSVs)){
      simSV = simSVs[v, ]
      ## Breakpoints can be either on 5' terminal or on 3' terminal
      ## Only check one breakpoint since the coordinates are only switched between chrB|chrA and chrA|chrB, but practically the same
      if(simSV$StartB == 1){
        simSV_Bp1 = GRanges(IRanges(simSV$EndB, simSV$EndB), seqnames=simSV$ChrB) ## 5', i.e. check the ends
      }else{
        simSV_Bp1 = GRanges(IRanges(simSV$StartB, simSV$StartB), seqnames=simSV$ChrB) ## 3', i.e. check the starts
      }
      if(simSV$StartA == 1){
        simSV_Bp2 = GRanges(IRanges(simSV$EndA, simSV$EndA), seqnames=simSV$ChrA) ## 5', i.e. check the ends
      }else{
        simSV_Bp2 = GRanges(IRanges(simSV$StartA, simSV$StartA), seqnames=simSV$ChrA) ## 3', i.e. check the starts
      }
      chr1 = as.character(seqnames(simSV_Bp1))
      chr2 = as.character(seqnames(simSV_Bp2))
      querySVs_Bp12 = c(querySVs_Bp1, querySVs_Bp2)
      ## If translocation is not balanced, the breakpoint sequence on chrA does not need to be checked
      if(simSV$Balanced == FALSE){
        overlap = .getOverlap(list(simSV_Bp1, simSV_Bp2), list(querySVs_Bp12[seqnames(querySVs_Bp12) == chr1], querySVs_Bp12[seqnames(querySVs_Bp12) == chr2]), list(simSV$BpSeqB, querySVs_Bp12[seqnames(querySVs_Bp12) == chr1]$bpSeq), list(NA, NA), tol, type)
        if(!is.null(overlap)){
          simSVs$Overlap[v] = overlap[[1]]
          simSVs$OverlapBpSeq_B[v] = overlap[[2]]
          numOverlaps = numOverlaps + overlap[[4]]
        }
      }else{
        overlap = .getOverlap(list(simSV_Bp1, simSV_Bp2), list(querySVs_Bp12[seqnames(querySVs_Bp12) == chr1], querySVs_Bp12[seqnames(querySVs_Bp12) == chr2]), list(simSV$BpSeqB, querySVs_Bp12[seqnames(querySVs_Bp12) == chr1]$bpSeq), list(simSV$BpSeqA, querySVs_Bp12[seqnames(querySVs_Bp12) == chr2]$bpSeq), tol, type)
        if(!is.null(overlap)){
          simSVs$Overlap[v] = overlap[[1]]
          simSVs$OverlapBpSeq_B[v] = overlap[[2]]
          simSVs$OverlapBpSeq_A[v] = overlap[[3]]
          numOverlaps = numOverlaps + overlap[[4]]
        }
      }
    }
  }

  ## report sensitivity and precision
  if(type == "insertion"){
    tp = numOverlaps
    fp = nrow(querySVs) - tp
    fn = sum(simSVs$Overlap_5prime == "") + sum(simSVs$Overlap_3prime == "")
  }
  else{
    tp = numOverlaps
    fp = nrow(querySVs) - tp
    fn = sum(simSVs$Overlap == "")
  }
  sensitivity = round((tp / (tp + fn)) * 100)
  precision = round((tp / (tp + fp)) * 100)
  message("Sensitivity: ", sensitivity, "%")
  message("Precision: ", precision, "%")

  return(simSVs)
  
}

## Uses nucleotideSubstitutionMatrix() and pairwiseAlignment() from the
## pwalign package.
.getOverlap <- function(sim, query, bpSeqA, bpSeqB, tol, type){

  ## simple substitution matrix, which only counts matches
  substitutionMatrix = pwalign::nucleotideSubstitutionMatrix(match = 1, mismatch = 0, baseOnly = FALSE, type = "DNA")

  start(query[[1]]) = start(query[[1]]) - tol
  end(query[[1]]) = end(query[[1]]) + tol
  start(query[[2]]) = start(query[[2]]) - tol
  end(query[[2]]) = end(query[[2]]) + tol
  overlap1 = as.matrix(findOverlaps(sim[[1]], query[[1]]))
  overlap2 = as.matrix(findOverlaps(sim[[2]], query[[2]]))
  if(nrow(overlap1) > 0 & nrow(overlap2) > 0){
    
    hit1 = overlap1[, "subjectHits"]
    hit2 = overlap2[, "subjectHits"]

#    if(query[[1]]$id[hit1] == query[[2]]$id[hit2]){
    ## for insertions and translocations, which have two breakpoints on two chromosomes, return two overlapping regions (separated by "; ")
    ## deletions, inversions and tandem duplications have only start and end, so return just one overlapping region
    ## returned regions include the given tolerance
    if(type == "insertion" | type == "translocation"){
      overlap = paste(paste(seqnames(query[[1]])[hit1], ":", start(query[[1]])[hit1]+tol, "-", end(query[[1]])[hit1]-tol, ", ", seqnames(query[[2]])[hit2], ":", start(query[[2]])[hit2]+tol, "-", end(query[[2]])[hit2]-tol, sep=""), collapse=", ")
    }else{
      overlap = paste(paste(seqnames(query[[1]])[hit1], ":", start(query[[1]])[hit1]+tol, "-", end(query[[2]])[hit2]-tol, sep=""), collapse=", ")
    }
    numOverlaps = length(hit1)
    bpSeqAlnScoreA = bpSeqAlnScoreB = NA
    if(!any(is.na(bpSeqA[[2]]))){
      ## align all overlaps and report the one with the maximum overlap
      bpSeqAlnScoreA = vector()
      for(h in hit1){
        bpSeqAlnScoreA = c(bpSeqAlnScoreA, pwalign::pairwiseAlignment(bpSeqA[[1]], bpSeqA[[2]][h], type="local", substitutionMatrix=substitutionMatrix, gapOpening=0, gapExtension=0, scoreOnly=TRUE))
      }
      bpSeqAlnScoreA = max(bpSeqAlnScoreA)
      bpSeqAlnScoreA = round((bpSeqAlnScoreA / nchar(bpSeqA[[1]])) * 100)
    }
    if(!any(is.na(bpSeqB[[2]]))){
      bpSeqAlnScoreB = vector()
      for(h in hit2){
        bpSeqAlnScoreB = c(bpSeqAlnScoreB, pwalign::pairwiseAlignment(bpSeqB[[1]], bpSeqB[[2]][h], type="local", substitutionMatrix=substitutionMatrix, gapOpening=0, gapExtension=0, scoreOnly=TRUE))
      }
      bpSeqAlnScoreB = max(bpSeqAlnScoreB)
      bpSeqAlnScoreB = round((bpSeqAlnScoreB / nchar(bpSeqB[[1]])) * 100)
    }
    return (list(overlap, bpSeqAlnScoreA, bpSeqAlnScoreB, numOverlaps))
  }
  return (NULL)

}


.readRepeatMaskerOutput <- function(file, save=TRUE){
  t = read.table(file, skip=2, fill=TRUE, stringsAsFactors=FALSE, colClasses=c("numeric","numeric","numeric","numeric","character","numeric","numeric","character","character","character","character","character","character","character","numeric"))

  t = t[t[, 5] %in% paste("chr", c(1:22,"X","Y"), sep=""), ]
  t = t[t[, 11] %in% c("LINE/L1","LINE/L2","SINE/Alu","SINE/MIR"), ]
  t[, 11] = gsub("LINE/","", t[, 11])
  t[, 11] = gsub("SINE/","", t[, 11])
  repeats = GRanges(IRanges(t[, 6], t[, 7]), seqnames=t[, 5], type=t[, 11])

  linesL1 = repeats[repeats$type == "L1"]
  linesL2 = repeats[repeats$type == "L2"]
  sinesAlu = repeats[repeats$type == "Alu"]
  sinesMIR = repeats[repeats$type == "MIR"]
  ## load previously saved segmental duplications to avoid import from UCSC browser
  if(file.exists(file.path(path.package("RSVSim"), "data", "segmentalDuplications.RData"))){
    data("segmentalDuplications", package="RSVSim", envir=environment())
  }else{
    require(rtracklayer)
    segDups = .loadFromUCSC_SegDups()
  }
  trs = .loadFromBSGenome_TandemRepeats()
  repeats = list(linesL1, linesL2, sinesAlu, sinesMIR, segDups, trs)
  if(save == TRUE){
    save(repeats, file=file.path(path.package("RSVSim"), "data", "repeats_hg19.RData"), compress="xz")
   }
  return(repeats)
}

## Loading the rmsk-track from UCSC may take up to 40 Minutes
.loadFromUCSC_RepeatMasks <- function(save=TRUE, verbose){
  
  ## from UCSV
  require(rtracklayer)
  chrs = paste("chr", c(1), sep="")
  mySession = browserSession("UCSC")
  genome(mySession) = "hg19"

  rmskTrack = ucscTableQuery(mySession, track="rmsk")
  chrs = paste("chr", c(1:22,"X","Y"), sep="")
  repeats = GRanges()

  if(verbose==TRUE) pb = txtProgressBar(min = 0, max = length(chrs), style = 3)

  for(i in 1:length(chrs)){
    c = chrs[i]
    rmskTrackChr = rmskTrack
    range(rmskTrackChr) = range(rmskTrackChr)[seqnames(range(rmskTrackChr)) == c]
    repeats_df = getTable(rmskTrackChr)
    repeats = c(repeats, GRanges(IRanges(repeats_df$genoStart, repeats_df$genoEnd), seqnames=factor(repeats_df$genoName, levels=chrs), type=as.character(repeats_df$repFamily)))
    
    if(verbose==TRUE) setTxtProgressBar(pb, i)

  }
  if(verbose==TRUE) close(pb)
  
  linesL1 = repeats[repeats$type == "L1"]
  linesL2 = repeats[repeats$type == "L2"]
  sinesAlu = repeats[repeats$type == "Alu"]
  sinesMIR = repeats[repeats$type == "MIR"]  
  ## load previously saved segmental duplications to avoid import from UCSC browser
  if(file.exists(file.path(path.package("RSVSim"), "data", "segmentalDuplications.RData"))){
    data("segmentalDuplications", package="RSVSim", envir=environment())
  }else{
    segDups = .loadFromUCSC_SegDups()
  }
  trs = .loadFromBSGenome_TandemRepeats()
  repeats = list(linesL1, linesL2, sinesAlu, sinesMIR, segDups, trs)
  if(save == TRUE){
    save(repeats, file=file.path(path.package("RSVSim"), "data", "repeats_hg19.RData"), compress="xz")
  }
  return(repeats)
}

.loadFromUCSC_SegDups <- function(){
  chrs = paste("chr", c(1:22,"X","Y"), sep="")

  mySession = browserSession("UCSC")
  genome(mySession) = "hg19"

  segDups = getTable(ucscTableQuery(mySession, track="genomicSuperDups"))
  segDups = segDups[segDups$chrom %in% chrs & segDups$otherChrom %in% chrs, ]
  segDups = c(
    GRanges(IRanges(segDups$chromStart, segDups$chromEnd), seqnames=as.character(segDups$chrom)),
    GRanges(IRanges(segDups$otherStart, segDups$otherEnd), seqnames=as.character(segDups$otherChrom))
    )
  segDups$type = "SD"
  
  return(segDups)
}

.loadFromBSGenome_TandemRepeats <- function(){
  ## this function requires BSgenome.Hsapiens.UCSC.hg19.masked to be loaded
  require(BSgenome.Hsapiens.UCSC.hg19.masked)
  Hsapiens_masked = BSgenome.Hsapiens.UCSC.hg19.masked
  chrs = paste("chr", c(1:22,"X","Y"), sep="")
  tr = GRanges()
  seqlevels(tr) = chrs
  for(c in chrs){
    t = as(masks(Hsapiens_masked[[c]])["TRF"], "data.frame")
    t = GRanges(IRanges(t$start, t$end), seqnames=c)
    seqlevels(t) = chrs
    tr = c(tr, t)
  }  
  tr$type = "TR"
  return(tr)
  
}


##########################################################################################################
## Methods for internal use only
##########################################################################################################


.getHG19 <- function(chrs){

  ## use library BSgenome.Hsapiens.UCSC.hg19 as default genome
  require(BSgenome.Hsapiens.UCSC.hg19)
  require(BSgenome.Hsapiens.UCSC.hg19.masked)
  Hsapiens_masked = BSgenome.Hsapiens.UCSC.hg19.masked

  if(any(is.na(chrs))){
    chrs = names(Hsapiens)[1:24]
  }
  genome = DNAStringSet()
  gaps = data.frame()
  for(c in chrs){
    genome = append(genome, DNAStringSet(DNAString(Hsapiens[[c]])))
    g = as(masks(Hsapiens_masked[[c]])["AGAPS"], "data.frame")
    g$seqnames = c
    gaps = rbind(gaps, g)
  }
  names(genome) = chrs
  gaps = GRanges(IRanges(gaps$start, gaps$end), seqnames=gaps$seqnames)
  return(list(genome, gaps))
}

.getDummyDataframe <- function(){
  return(data.frame(seqnames=0,start=0,end=0,mechanism="", bpRegion="", stringsAsFactors=FALSE)[-1, ])
}

## subtract interval list from other interval list (both GRanges objects)
## e.g. subtract gaps from genome ranges
.subtractIntervals <- function(subject, subtrahend){
  
#  diff = setdiff(disjoin(c(subject,subtrahend)), subtrahend)
  diff = setdiff(subject, subtrahend)
  seqlevels(diff) = unique(as.character(seqnames(diff)))
  return(diff)
  
}

subject = GRanges(IRanges(c(1,11,21),c(10,20,30)), seqnames=c("A","B","C"), type=c("t1","t2","t3"))
names(subject) = c("t1","t2")
subtrahend = GRanges(IRanges(c(4,6),c(14,16)), seqnames=c("A","B"), type=c("t4","t5"))
names(subtrahend) = c("t3","t4")

## These functions are only for internal purposes
.testSVSim <- function(){

  runs = 10
  
  for(i in 1:runs){
    message("+++++++++++++++ Test run ", i, " ++++++++++++++++++++++++++++++")
  
    size1 = 20000000
    size2 = 15000000
    size3 = 10000000
    size4 = 5000000
    size5 = 1000000
    size6 = 500000
    genome = DNAStringSet(c(
      paste(sample(c("A","G","T","C"), size1, replace=TRUE), collapse=""),
      paste(sample(c("A","G","T","C"), size2, replace=TRUE), collapse=""),
      paste(sample(c("A","G","T","C"), size3, replace=TRUE), collapse=""),
      paste(sample(c("A","G","T","C"), size4, replace=TRUE), collapse=""),
      paste(sample(c("A","G","T","C"), size5, replace=TRUE), collapse=""),
      paste(sample(c("A","G","T","C"), size6, replace=TRUE), collapse="")
      ))
    names(genome) = c("chr1","chr2","chr3","chr4","chr5","chr6")
    
    dels = 100
    ins = 100
    invs = 100
    dups = 100
    trans = 5
    sizeDels = sample(1000:5000, dels, replace=TRUE)
    sizeIns = sample(1000:5000, ins, replace=TRUE)
    sizeInvs = sample(1000:5000, invs, replace=TRUE)
    sizeDups = sample(1000:5000, dups, replace=TRUE)
    bpSeqSize = 300
    sim = simulateSV(output=NA, genome=genome, dels=dels, ins=ins, invs=invs, dups=dups, trans=trans, sizeDels=sizeDels, sizeIns=sizeIns, sizeInvs=sizeInvs, sizeDups=sizeDups, maxDups=10, bpSeqSize=bpSeqSize, random=TRUE, repeatBias=FALSE, percSNPs=0, indelProb=0)

    ## sim2 is for testing the non-random implementation of predefined sv regions
    regionsDels = GRanges(IRanges(metadata(sim)$deletions$Start, metadata(sim)$deletions$End), seqnames=metadata(sim)$deletions$Chr)
    regionsIns = GRanges(IRanges(metadata(sim)$insertions$StartA, metadata(sim)$insertions$EndA), seqnames=metadata(sim)$insertions$ChrA, chrB=metadata(sim)$insertions$ChrB, startB=metadata(sim)$insertions$StartB, endB=metadata(sim)$insertions$EndB)
    regionsInvs = GRanges(IRanges(metadata(sim)$inversions$Start, metadata(sim)$inversions$End), seqnames=metadata(sim)$inversions$Chr)
    regionsDups = GRanges(IRanges(metadata(sim)$tandemDuplications$Start, metadata(sim)$tandemDuplications$End), seqnames=metadata(sim)$tandemDuplications$Chr)
    regionsTrans = GRanges(IRanges(metadata(sim)$translocations$StartA, metadata(sim)$translocations$EndA), seqnames=metadata(sim)$translocations$ChrA, chrB=metadata(sim)$translocations$ChrB, startB=metadata(sim)$translocations$StartB, endB=metadata(sim)$translocations$EndB)
    sim2 = simulateSV(output=NA, genome=genome, dels=dels, ins=ins, invs=invs, dups=dups, trans=trans, sizeDels=sizeDels, sizeIns=sizeIns, sizeInvs=sizeInvs, sizeDups=sizeDups, regionsDels=regionsDels, regionsIns=regionsIns, regionsInvs=regionsInvs, regionsDups=regionsDups, regionsTrans=regionsTrans, maxDups=10, bpSeqSize=bpSeqSize, random=FALSE, repeatBias=FALSE, percSNPs=0, indelProb=0)
    sim = sim2
    
    bpSeqSize = bpSeqSize / 2
    maxMismatch = 0
    for(type in c("deletions","insertions","inversions","tandemDuplications","translocations")){
      sv = metadata(sim)[[type]]
      
      ## Deletions ################################
      if(type == "deletions"){
        iscorrect = c()
        for(i in 1:nrow(sv)){
          seq = DNAString(sv$BpSeq[i])
          aln = matchPattern(subseq(seq, 1, bpSeqSize), genome[[as.character(sv$Chr[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          s = (start(aln) == (sv$Start[i] - bpSeqSize))
          aln = matchPattern(subseq(seq, bpSeqSize+1, bpSeqSize*2), genome[[as.character(sv$Chr[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          e = (end(aln) == (sv$End[i] + bpSeqSize))
          iscorrect = c(iscorrect, s & e)
        }
        message(type, ": ", round(sum(iscorrect)/nrow(sv), digits=2)*100, " % correct ")
        if(any(!iscorrect)){
          message(type, paste(sv$Type[!iscorrect], collapse=","), " are not correct")
        }
      }
      ## Inversions ################################
      if(type == "inversions"){
        iscorrect = c()
        for(i in 1:nrow(sv)){
          
          ## 5' breakpoint sequence
          seq = DNAString(sv$BpSeq_5prime[i])
          aln = matchPattern(subseq(seq, 1, bpSeqSize), genome[[as.character(sv$Chr[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          s = (start(aln) == (sv$Start[i] - bpSeqSize))
          aln = matchPattern(reverseComplement(subseq(seq, bpSeqSize+1, bpSeqSize*2)), genome[[as.character(sv$Chr[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          e = (end(aln) == sv$End[i])
          iscorrect = c(iscorrect, s & e)
          
          ## 3' breakpoint sequence
          seq = DNAString(sv$BpSeq_3prime[i])
          aln = matchPattern(reverseComplement(subseq(seq, 1, bpSeqSize)), genome[[as.character(sv$Chr[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          s = (start(aln) == sv$Start[i])
          aln = matchPattern(subseq(seq, bpSeqSize+1, bpSeqSize*2), genome[[as.character(sv$Chr[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          e = (end(aln) == (sv$End[i]+ bpSeqSize))
          iscorrect = c(iscorrect, s & e)
        }
        message(type, ": ", round(sum(iscorrect)/(nrow(sv)*2), digits=2)*100, " % correct ")
        if(any(!iscorrect)){
          message(type, paste(sv$Type[!iscorrect], collapse=","), " are not correct")
        }
      }
      
      ## Insertions ################################
      if(type == "insertions"){
        iscorrect = c()
        for(i in 1:nrow(sv)){
          
          ## breakpoint sequence A (deleted segment)
          seq = DNAString(sv$BpSeqA[i])
          aln = matchPattern(subseq(seq, 1, bpSeqSize), genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          s = (start(aln) == (sv$StartA[i] - bpSeqSize))
          aln = matchPattern(subseq(seq, bpSeqSize+1, bpSeqSize*2), genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          e = (end(aln) == (sv$EndA[i] + bpSeqSize))
          iscorrect = c(iscorrect, s & e)
          
          ## breakpoint sequence B 5'
          seq = DNAString(sv$BpSeqB_5prime[i])
          aln = matchPattern(subseq(seq, 1, bpSeqSize), genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          s = (start(aln) == (sv$StartB[i] - bpSeqSize))
          aln = matchPattern(subseq(seq, bpSeqSize+1, bpSeqSize*2), genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          e = (start(aln) == sv$StartA[i])
          iscorrect = c(iscorrect, s & e)
          
          ## breakpoint sequence B 3'
          seq = DNAString(sv$BpSeqB_3prime[i])
          aln = matchPattern(subseq(seq, 1, bpSeqSize), genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          s = (end(aln) == sv$EndA[i])
          aln = matchPattern(subseq(seq, bpSeqSize+1, bpSeqSize*2), genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          e = (start(aln) == sv$StartB[i])
          
          iscorrect = c(iscorrect, s & e)
          
        }
        message(type, ": ", round(sum(iscorrect)/(nrow(sv)*3), digits=2)*100, " % correct ")
        if(any(!iscorrect)){
          message(type, paste(sv$Type[!iscorrect], collapse=","), " are not correct")
        }
      }    
      ## Tandem duplications ################################
      if(type == "tandemDuplications"){
        iscorrect = c()
        for(i in 1:nrow(sv)){
          seq = DNAString(sv$BpSeq[i])
          aln = matchPattern(subseq(seq, 1, bpSeqSize), genome[[as.character(sv$Chr[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          s = (end(aln) == sv$End[i])
          aln = matchPattern(subseq(seq, bpSeqSize+1, bpSeqSize*2), genome[[as.character(sv$Chr[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          e = (start(aln) == sv$Start[i])
          ## also test the number of duplication
          aln = matchPattern(seq, sim[[as.character(sv$Chr[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
          d = ((length(aln)+1) == sv$Duplications[i])
          iscorrect = c(iscorrect, s & e & d)
        }
        message(type, ": ", round(sum(iscorrect)/nrow(sv), digits=2)*100, " % correct ")
        if(any(!iscorrect)){
          message(type, paste(sv$Type[!iscorrect], collapse=","), " are not correct")
        }
      }
      ## Translocations ################################
      if(type == "translocations"){
        iscorrect = c()
        for(i in 1:nrow(sv)){
          
          ## breakpoint sequence A
          seq = DNAString(sv$BpSeqA[i])
          ## case xxx... <-> ...xxx
          if(sv$StartA[i] == 1 & sv$StartB[i] != 1){
            seq1 = reverseComplement(subseq(seq, 1, bpSeqSize))
            aln = matchPattern(seq1, genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
            s = (start(aln) == sv$StartB[i])
            seq2 = subseq(seq, bpSeqSize+1, bpSeqSize*2)
            aln = matchPattern(seq2, genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
            e = (end(aln) == sv$EndA[i] + bpSeqSize)
          }
          ## case ...xxx <-> xxx...
          if(sv$StartA[i] != 1 & sv$StartB[i] == 1){
            seq1 = subseq(seq, 1, bpSeqSize)
            aln = matchPattern(seq1, genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
            s = (start(aln) == sv$StartA[i] - bpSeqSize)
            seq2 = reverseComplement(subseq(seq, bpSeqSize+1, bpSeqSize*2))
            aln = matchPattern(seq2, genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
            e = (end(aln) == sv$EndB[i])
          }
          ## case xxx... <-> xxx...
          if(sv$StartA[i] == 1 & sv$StartB[i] == 1){
            seq1 = subseq(seq, 1, bpSeqSize)
            aln = matchPattern(seq1, genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
            s = (end(aln) == sv$EndB[i])
            seq2 = subseq(seq, bpSeqSize+1, bpSeqSize*2)
            aln = matchPattern(seq2, genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
            e = (end(aln) == (sv$EndA[i] + bpSeqSize))
          }
          ## case ...xxx <-> ...xxx
          if(sv$StartA[i] != 1 & sv$StartB[i] != 1){
            seq1 = subseq(seq, 1, bpSeqSize)
            aln = matchPattern(seq1, genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
            s = (start(aln) == sv$StartA[i] - bpSeqSize)
            seq2 = subseq(seq, bpSeqSize+1, bpSeqSize*2)
            aln = matchPattern(seq2, genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
            e = (start(aln) == sv$StartB[i])
          }
          iscorrect = c(iscorrect, s & e)
          
          ## breakpoint sequence B
          seq = DNAString(sv$BpSeqB[i])
          if(sv$Balanced[i] == TRUE){
            ## case xxx... <-> ...xxx
            if(sv$StartA[i] == 1 & sv$StartB[i] != 1){
              seq1 = subseq(seq, 1, bpSeqSize)
              aln = matchPattern(seq1, genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
              s = (start(aln) == sv$StartB[i] - bpSeqSize)
              seq2 = reverseComplement(subseq(seq, bpSeqSize+1, bpSeqSize*2))
              aln = matchPattern(seq2, genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
              e = (end(aln) == sv$EndA[i])
            }
            ## case ...xxx <-> xxx...
            if(sv$StartA[i] != 1 & sv$StartB[i] == 1){
              seq1 = reverseComplement(subseq(seq, 1, bpSeqSize))
              aln = matchPattern(seq1, genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
              s = (start(aln) == sv$StartA[i])
              seq2 = subseq(seq, bpSeqSize+1, bpSeqSize*2)
              aln = matchPattern(seq2, genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
              e = (end(aln) == sv$EndB[i] + bpSeqSize)
            }
            ## case xxx... <-> xxx...
            if(sv$StartA[i] == 1 & sv$StartB[i] == 1){
              seq1 = subseq(seq, 1, bpSeqSize)
              aln = matchPattern(seq1, genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
              s = (end(aln) == sv$EndA[i])
              seq2 = subseq(seq, bpSeqSize+1, bpSeqSize*2)
              aln = matchPattern(seq2, genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
              e = (end(aln) == (sv$EndB[i] + bpSeqSize))
            }
            ## case ...xxx <-> ...xxx
            if(sv$StartA[i] != 1 & sv$StartB[i] != 1){
              seq1 = subseq(seq, 1, bpSeqSize)
              aln = matchPattern(seq1, genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
              s = (start(aln) == sv$StartB[i] - bpSeqSize)
              seq2 = subseq(seq, bpSeqSize+1, bpSeqSize*2)
              aln = matchPattern(seq2, genome[[as.character(sv$ChrA[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
              e = (start(aln) == sv$StartA[i])
            }
            iscorrect = c(iscorrect, s & e)
          }else{
            seq = DNAString(sv$BpSeqB[i])
            aln = matchPattern(seq, genome[[as.character(sv$ChrB[i])]], with.indels=TRUE, max.mismatch=maxMismatch)
            s = (start(aln) == (sv$StartB[i] - bpSeqSize)) | (end(aln) == (sv$EndB[i] + bpSeqSize))
            iscorrect = c(iscorrect, s)
          }        
        }
        message(type, ": ", round(sum(iscorrect)/(nrow(sv)*2), digits=2)*100, " % correct ")
        if(any(!iscorrect)){
          message(type, paste(sv$Type[!iscorrect], collapse=","), " are not correct")
        }
      }
    }   
  }
}

setMethod("simulateSV",
          signature(),

          function(output, genome, chrs, dels, ins, invs, dups, trans, size, sizeDels, sizeIns, sizeInvs, sizeDups, regionsDels, regionsIns, regionsInvs, regionsDups, regionsTrans, maxDups, percCopiedIns, percBalancedTrans, bpFlankSize, percSNPs, indelProb, maxIndelSize, repeatBias, weightsMechanisms, weightsRepeats, repeatMaskerFile, bpSeqSize, random, seed, verbose){

              
  options(stringsAsFactors=FALSE, scipen=10)
  
  if(!missing(seed)){ 
    set.seed(seed)
  }

  ## default for random is TRUE
  ## is only one value given, set it for all SVs where regions were specified (only place, where a FALSE makes sense)
  if(length(random) == 1){
    r = rep(TRUE, 5)
    r[!c(missing(regionsDels), missing(regionsIns), missing(regionsInvs), missing(regionsDups), missing(regionsTrans))] = random
    random = r
  }
  
  .validateInput(output, genome, chrs, dels, ins, invs, dups, trans, sizeDels, sizeIns, sizeInvs, sizeDups, regionsDels, regionsIns, regionsInvs, regionsDups, regionsTrans, maxDups, percCopiedIns, percBalancedTrans, percSNPs, indelProb, weightsMechanisms, weightsRepeats, bpSeqSize, random, seed)

  ## see if genome is given
  ## if not, read the hg19 by default
  if(missing(genome)){
    if(verbose==TRUE) message("Loading human genome (hg19)")
    if(missing(chrs)){
      genome = .getHG19(NA)
    }else{
      genome = .getHG19(chrs)
    }
    gaps = genome[[2]]
    genome = genome[[1]]
    chrs = names(genome)
    genomeOrganism = "hg19"
  ## if genome is given, there are two possibilities:
  ## 1. genome is a filename pointing to a FASTA-file
  ## 2. genome is a named DNAStringSet
  }else{
    if(class(genome) == "character"){
      if(verbose==TRUE) message("Loading genome from FASTA file: ", genome)
      genome = readDNAStringSet(filepath=genome)  ## read genome from FASTA-file
    }
    if(missing(chrs)){
      chrs = names(genome)
    }else{
		genome = genome[match(chrs, names(genome))]
	}
    ## compute gaps within the given genome (N-sequences)
    gaps = GRanges()
    for(chr in chrs){
      Ns = whichAsIRanges(as.integer(genome[[chr]]) == as.integer(DNAString("N")))
      if(length(Ns) > 0){
        gaps = c(gaps, GRanges(Ns, seqnames=chr))
      }
    }
    genomeOrganism = "unknown"
  }
  gaps = as.data.frame(gaps)[, 1:3]
  genomeCoords = GRanges(IRanges(start=1, end=width(genome)), seqnames=names(genome))

  ## for the default case, i.e. simulation on the hg19:
  ## set the weights for the sv formation mechanisms and their occurence within certain repeat regions
  ## default values for SV formation mechanisms were derived from:
  ## deletions, insertions/duplications: Mills et al., Mapping copy number variation by population-scale genome sequencing
  ## inversions: Pang et al., Mechanisms of Formation of Structural Variation in a Fully Sequenced Human Genome
  ## translocations: Ou et al., Observation and prediction of recurrent human translocations mediated by NAHR between nonhomologous chromosomes & Chen et al., Mapping translocation breakpoints by next-generation sequencing
  
  ## default values for repeat regions enriched for SV formation mechanisms were derived from:
  ## Lam et al., Nucleotide-resolution analysis of structural variants using BreakSeq and a breakpoint library (Supplemental Table 5)

  ## in this order: NAHR, NHR, TEI, VNTR, other
  mechanisms = c("NAHR","NHR","TEI","VNTR","Other")
  bpTypes = c("L1","L2","Alu","MIR","SD","TR","Random")

  ## for simulation on hg19 set the weights for the repeat elements (if not given by the user)
  ## for simulation on any other organism (user specified genome), set the weights to zero except for random simulation (i.e. turn this feature off)
  if(missing(weightsMechanisms)){
	if(genomeOrganism == "hg19" & repeatBias){
      data("weightsMechanisms", package="RSVSim", envir=environment())
    }else{
      weightsMechanisms = data.frame(
        dels = c(0,0,0,0,1),
        ins = c(0,0,0,0,1),
        invs = c(0,0,0,0,1),
        dups = c(0,0,0,0,1),
        trans = c(0,0,0,0,1)
        )
      rownames(weightsMechanisms) = mechanisms
    }
  }  
  if(missing(weightsRepeats)){
    if(genomeOrganism == "hg19" & repeatBias){
      data("weightsRepeats", package="RSVSim", envir=environment())
    }else{
      weightsRepeats = data.frame(
        NAHR = c(0,0,0,0,0,0,0),
        NHR = c(0,0,0,0,0,0,0),
        TEI = c(0,0,0,0,0,0,0),
        VNTR = c(0,0,0,0,0,0,0),
        Other = c(0,0,0,0,0,0,1)
        )
      rownames(weightsRepeats) = bpTypes
    }
  }

  ## several options to get the repeatmasker regions:
  ## 1. bp shall be placed randomly (no bpWeights)
  ## then, only use all the genomic coordinates without special weighting for repeats
  if(genomeOrganism != "hg19" | !repeatBias | all(random) == FALSE){
    if(genomeOrganism == "hg19"){
      if(verbose==TRUE) message("Bias for hg19 repeat regions is turned OFF")
    }else{
      if(verbose==TRUE) message("Breakpoints will be distributed uniformly across the genome")
    }
    bpRegions = vector(mode="list", length=1)
    names(bpRegions) = "Random"
  }else{
    if(verbose==TRUE) message("Bias for hg19 repeat regions is turned ON")
    ## 2. repeatMasker regions were loaded and saved to disk once befoe in the data directory of the package
    ## then just load the data
    if(file.exists(file.path(path.package("RSVSim"), "data", "repeats_hg19.RData"))){
      if(verbose==TRUE) message("Loading hg19 repeat regions")
      data("repeats_hg19", package="RSVSim", envir=environment())  ## loads object named "repeats"
    }else{
      ## 3. filename of repeatmasker file is given (file downloaded from http://www.repeatmasker.org/genomes/hg19/RepeatMasker-rm330-db20120124/hg19.fa.out.gz)
      ## then, read the file, extract LINES,SINES and read segmental duplications from UCSC
      if(!missing(repeatMaskerFile)){
        if(verbose==TRUE) message("Loading hg19 repeat regions for the first time from given RepeatMasker output file")
        repeats = .readRepeatMaskerOutput(repeatMaskerFile)
        if(file.exists(file.path(path.package("RSVSim"), "data", "repeats_hg19.RData"))){
         if(verbose==TRUE)  message("Repeat regions were saved to ", file.path(path.package("RSVSim"), "data", "repeats_hg19.RData"), " for faster access next time")
        }else{
          warning("Saving of repeat regions to ", file.path(path.package("RSVSim"), "data", "repeats_hg19.RData"), " failed")
        }
      }
      ## 4. no repeatMasker file is given
      ## then, read the repeatMasker track and the segmental duplications from UCSC via rTracklayer package
      else{
        if(verbose==TRUE) message("Loading hg19 repeat regions for the first time from the UCSC Browser's RepeatMasker track (this may take up to 45 minutes)")
        repeats = .loadFromUCSC_RepeatMasks(save=TRUE, verbose=verbose)  
        if(file.exists(file.path(path.package("RSVSim"), "data", "repeats_hg19.RData"))){
         if(verbose==TRUE)  message("Repeat regions were saved to ", file.path(path.package("RSVSim"), "data", "repeats_hg19.RData"), " for faster access next time")
        }else{
          warning("Saving of repeat regions to ", file.path(path.package("RSVSim"), "data", "repeats_hg19.RData"), " failed")
        }
      }
    }
    repeats = lapply(repeats, function(r) return(r[seqnames(r) %in% chrs]))
    repeats = lapply(repeats, function(r) return(reduce(r, min.gapwidth=50)))  # merge repeats which are only 100bp away from each other
    bpRegions = vector(mode="list", length=length(repeats)+1)
    names(bpRegions) = bpTypes
    bpRegions[1:length(repeats)] = repeats
    rm(repeats)
  }

  ## put SVs anywhere in the genome if no regions were specified
  ## if regions were given, take care, that the regions lie within the available chromosomes

  if(missing(regionsDels)){
    regionsDels = genomeCoords
  }else{
    regionsDels = regionsDels[seqnames(regionsDels) %in% intersect(chrs, as.character(seqnames((regionsDels))))]
    if(length(regionsDels) == 0){
      stop("No regions on given chromosomes")
    }
    ## for non-random distribution, set number of deletions to number of given regions
    if(random[1] == FALSE){
      dels = length(regionsDels)
    }
  }
  if(missing(regionsIns)){
    regionsIns = genomeCoords
  }else{
    if(random[2] == TRUE){
      regionsIns = regionsIns[seqnames(regionsIns) %in% intersect(chrs, as.character(seqnames((regionsIns))))]
    }else{
      regionsIns = regionsIns[seqnames(regionsIns) %in% intersect(chrs, as.character(seqnames((regionsIns)))) & regionsIns$chrB %in% chrs]
      ins = length(regionsIns)
    }
    if(length(regionsIns) == 0){
      stop("No regions on given chromosomes")
    }
  }
  if(missing(regionsInvs)){
    regionsInvs = genomeCoords
  }else{
    regionsInvs = regionsInvs[seqnames(regionsInvs) %in% intersect(chrs, as.character(seqnames((regionsInvs))))]
    if(length(regionsInvs) == 0){
      stop("No regions on given chromosomes")
    }
    ## for non-random distribution, set number of inversions to number of given regions
    if(random[3] == FALSE){
      invs = length(regionsInvs)
    }
  }
  if(missing(regionsDups)){
    regionsDups = genomeCoords
    dupTimes = sample(1:(maxDups-1), dups, replace=TRUE) + 1
  }else{
    regionsDups = regionsDups[seqnames(regionsDups) %in% intersect(chrs, as.character(seqnames((regionsDups))))]
    if(length(regionsDups) == 0){
      stop("No regions on given chromosomes")
    }
    ## for non-random distribution, set number of duplications to number of given regions
    dupTimes = sample(1:(maxDups-1), length(regionsDups), replace=TRUE) + 1
    if(random[4] == FALSE){
      dups = length(regionsDups)
      if(ncol(mcols(regionsDups)) > 0){
		  if("times" %in% colnames(mcols(regionsDups))){
			dupTimes = mcols(regionsDups)$times
		  }
	  }
    }
  }
  if(missing(regionsTrans)){
    regionsTrans = genomeCoords
  }else{
    if(random[5] == TRUE){
      regionsTrans = regionsTrans[seqnames(regionsTrans) %in% intersect(chrs, as.character(seqnames((regionsTrans))))]
    }else{
      regionsTrans = regionsTrans[seqnames(regionsTrans) %in% intersect(chrs, as.character(seqnames((regionsTrans)))) & regionsTrans$chrB %in% chrs]
      trans = length(regionsTrans)
    }
    if(length(regionsTrans) == 0){
      stop("No regions on given chromosomes")
    }
  }

  ## restrict SV regions to given chromosomes

  ## inversion and deletion sizes
  if((length(sizeDels) > 1 & length(sizeDels) != dels) | (length(sizeIns) > 1 & length(sizeIns) != ins) | (length(sizeInvs) > 1 & length(sizeInvs) != invs) | (length(sizeDups) > 1 & length(sizeDups) != dups)){
    warning("Length of vectors with SV sizes vary from the number of SVs")
  }
  if(!missing(size)){
    sizeDels = sizeIns = sizeInvs = sizeDups = size
  }
  
  sizeDels = rep(sizeDels, dels)[1:dels]
  sizeIns = rep(sizeIns, ins)[1:ins]
  sizeInvs = rep(sizeInvs, invs)[1:invs]
  sizeDups = rep(sizeDups, dups)[1:dups]
  
  ## bpSeqSize will be used two times, in upstream and downstream direction; so divide it hear by two
  bpSeqSize = round(bpSeqSize / 2)

  ## Simulation ############################################################

  ## 1. simulate regions for translocations:
  type = "translocation"
  translocations = posTrans_1 = posTrans_2 = NULL
  if(random[5] == TRUE){
    ## 1.1 for chromosome terminals
    if(trans > 0){
      if(verbose==TRUE) message("Calculating coordinates: ", trans, " translocations")
    
      subtrahend = gaps[, c("seqnames","start","end")]
      subtrahend = GRanges(IRanges(subtrahend$start, subtrahend$end), seqnames=subtrahend$seqnames)
      regionsTrans  = .subtractIntervals(regionsTrans, subtrahend)
      bpRegions[["Random"]] = regionsTrans
      t = .simTranslocationPositions(trans, bpRegions, weightsMechanisms[, "trans", drop=FALSE], weightsRepeats, genome, percBalancedTrans, c(), verbose)
      translocations = t[[1]]
      posTrans_1 = t[[2]]
      posTrans_2 = t[[3]]
    }   
  }else{
    if(verbose==TRUE) message("Using given coordinates: Translocations")    
    trans = length(regionsTrans)
    posTrans_1 = as.data.frame(regionsTrans)
    posTrans_1$names = rownames(posTrans_1)
    posTrans_2 = as.data.frame(regionsTrans)[, c("chrB","startB","endB")]
    colnames(posTrans_2) = c("seqnames","start","end")
    
    ## Add balanced information (default:TRUE) if not given
    if(!("balanced" %in% colnames(posTrans_1)) | !("balanced" %in% colnames(posTrans_2))){
      posTrans_1$balanced = posTrans_2$balanced = TRUE
    }
    ## Determine wich translocations need to be inverted (segments on different ends of chromosomes)
    idx = which((posTrans_1$start == 1 & posTrans_2$start != 1) | (posTrans_1$start != 1 & posTrans_2$start == 1))
    posTrans_1$inverted = posTrans_2$inverted = FALSE
    posTrans_1$inverted[idx] = posTrans_2$inverted[idx] = TRUE

    size1 = posTrans_1$end-posTrans_1$start+1
    size2 = posTrans_2$end-posTrans_2$start+1
    translocations = cbind(posTrans_1$names, posTrans_1[, c("seqnames","start","end")], size1, posTrans_2[, c("seqnames","start","end")], size2, posTrans_2$balanced)
    colnames(translocations) = c("Name", "ChrA", "StartA", "EndA", "SizeA", "ChrB", "StartB", "EndB", "SizeB","Balanced")
  }

  ## 2. simulate insertions
  type = "insertion"
  insertions = posIns_1 = posIns_2 = NULL
  if(random[2] == TRUE){
    if(ins > 0){
      if(verbose==TRUE) message("Calculating coordinates: ", ins, " insertions")  
      
      subtrahend = rbind(gaps[, c("seqnames","start","end")], posTrans_1[, c("seqnames","start","end")], posTrans_2[, c("seqnames","start","end")])
      subtrahend = GRanges(IRanges(subtrahend$start, subtrahend$end), seqnames=subtrahend$seqnames)
      regionsIns  = .subtractIntervals(regionsIns, subtrahend)
      bpRegions[["Random"]] = regionsIns
      i = .simInsertionPositions(ins, bpRegions, weightsMechanisms[, "ins", drop=FALSE], weightsRepeats, genome, sizeIns, percCopiedIns, verbose)
      insertions = i[[1]]
      posIns_1 = i[[2]]
      posIns_2 = i[[3]]
    }
  }else{
    if(verbose==TRUE) message("Using given coordinates: Insertions")    
    ins = length(regionsIns)
    posIns_1 = as.data.frame(regionsIns)
    size = posIns_1$end-posIns_1$start+1
    posIns_1$names = rownames(posIns_1)
    posIns_2 = as.data.frame(regionsIns)[, c("chrB","startB")]
    posIns_2$endB = posIns_2$startB + size - 1
    colnames(posIns_2) = c("seqnames","start","end")
    ## Add duplicate information (default:FALSE) if not given
    if(!("copied" %in% colnames(posIns_1))){
      posIns_1$copied = posIns_2$copied = FALSE
    }
 
    insertions = cbind(posIns_1$names, posIns_1[rownames(posIns_1), c("seqnames","start","end")], posIns_2[rownames(posIns_1), c("seqnames","start","end")], size, posIns_1$copied)
    colnames(insertions) = c("Name", "ChrA", "StartA", "EndA", "ChrB", "StartB", "EndB", "Size", "Copied")
  }

  ## 3. simulate deletions
  type = "deletion"
  deletions = posDel = NULL
  if(random[1] == TRUE){
    if(dels > 0){
      if(verbose==TRUE) message("Calculating coordinates: ", dels, " deletions")
      
      subtrahend = rbind(gaps[, c("seqnames","start","end")], posIns_1[, c("seqnames","start","end")], posIns_2[, c("seqnames","start","end")], posTrans_1[, c("seqnames","start","end")], posTrans_2[, c("seqnames","start","end")])
      subtrahend = GRanges(IRanges(subtrahend$start, subtrahend$end), seqnames=subtrahend$seqnames)
      regionsDels = .subtractIntervals(regionsDels, subtrahend)
      bpRegions[["Random"]] = regionsDels
      d = .simPositions(dels, bpRegions, weightsMechanisms[, "dels", drop=FALSE], weightsRepeats, sizeDels, "deletion", verbose)
      deletions = d[[1]]
      posDel = d[[2]]
    }
  }else{
    if(verbose==TRUE) message("Using given coordinates: Deletions")
    dels = length(regionsDels)
    posDel = as.data.frame(regionsDels)
    posDel$names = rownames(posDel)
    size=posDel$end-posDel$start+1
    deletions = cbind(posDel$names, posDel[, c("seqnames","start","end")], size)
    colnames(deletions) = c("Name", "Chr", "Start","End","Size")
  }
  
  ## 4. simulate inversions
  type = "inversion"
  inversions = posInv = NULL
  if(random[3] == TRUE){
    if(invs > 0){
      if(verbose==TRUE) message("Calculating coordinates: ", invs, " inversions")
      
      subtrahend = rbind(gaps[, c("seqnames","start","end")], posDel[, c("seqnames","start","end")], posIns_1[, c("seqnames","start","end")], posIns_2[, c("seqnames","start","end")], posTrans_1[, c("seqnames","start","end")], posTrans_2[, c("seqnames","start","end")])
      subtrahend = GRanges(IRanges(subtrahend$start, subtrahend$end), seqnames=subtrahend$seqnames)
      regionsInvs  = .subtractIntervals(regionsInvs, subtrahend)
      bpRegions[["Random"]] = regionsInvs
      i = .simPositions(invs, bpRegions, weightsMechanisms[, "invs", drop=FALSE], weightsRepeats, sizeInvs, type, verbose)
      inversions = i[[1]]
      posInv = i[[2]]
    }
  }else{
    if(verbose==TRUE) message("Using given coordinates: Inversions")
    invs = length(regionsInvs)
    posInv = as.data.frame(regionsInvs)
    posInv$names = rownames(posInv)
    size=posInv$end-posInv$start+1
    inversions = cbind(posInv$names, posInv[, c("seqnames","start","end")], size)
    colnames(inversions) = c("Name","Chr", "Start","End", "Size")
  }
  
  ## 5. simulate tandem duplications
  type = "tandemDuplication"
  tandemDups = posDup = NULL
  if(random[4] == TRUE){
    if(dups > 0){
      if(verbose==TRUE) message("Calculating coordinates: ", dups, " tandem duplications")
      
      subtrahend = rbind(gaps[, c("seqnames","start","end")], posDel[, c("seqnames","start","end")], posIns_1[, c("seqnames","start","end")], posIns_2[, c("seqnames","start","end")], posInv[, c("seqnames","start","end")], posTrans_1[, c("seqnames","start","end")], posTrans_2[, c("seqnames","start","end")])
      subtrahend = GRanges(IRanges(subtrahend$start, subtrahend$end), seqnames=subtrahend$seqnames)
      regionsDups  = .subtractIntervals(regionsDups, subtrahend)
      bpRegions[["Random"]] = regionsDups
      td = .simPositions(dups, bpRegions, weightsMechanisms[, "dups", drop=FALSE], weightsRepeats, sizeDups, type, verbose)
      tandemDups = td[[1]]
      posDup = td[[2]]
    }
  }else{
    if(verbose==TRUE) message("Using given coordinates: Tandem Duplications")
    dups = length(regionsDups)
    posDup = as.data.frame(regionsDups)
    posDup$names = rownames(posDup)
    size=posDup$end-posDup$start+1
    tandemDups = cbind(posDup$names, posDup[, c("seqnames","start","end")], size)
    colnames(tandemDups) = c("Name","Chr", "Start","End", "Size")
  }
  
  ## Execution: implement regions into genome sequence ############################################################
    
  ## 1. inversions
  if(invs > 0){
    if(verbose==TRUE) message("Rearranging genome: Inversions")
    if(verbose==TRUE) pb = txtProgressBar(min = 0, max = invs, style = 3)
    for(i in 1:invs){

      chr = as.character(posInv$seqnames[i])
      rearrangement = .execInversion(genome[[chr]], chr, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, bpSeqSize, i, bpFlankSize, percSNPs, indelProb, maxIndelSize)
      genome[[chr]] = rearrangement[[1]]
      posDel = rearrangement[[2]]
      posIns_1 = rearrangement[[3]]
      posIns_2 = rearrangement[[4]]
      posInv = rearrangement[[5]]
      posDup = rearrangement[[6]]
      posTrans_1 = rearrangement[[7]]
      posTrans_2 = rearrangement[[8]]
      
      if(verbose==TRUE) setTxtProgressBar(pb, i)
      
    }
    if(verbose==TRUE) close(pb)
  }

  
  ## 2. translocations
  if(trans > 0){
    if(verbose==TRUE) message("Rearranging genome: Translocations")
    if(verbose==TRUE) pb = txtProgressBar(min = 0, max = trans, style = 3)
    for(i in 1:trans){
      chr1 = as.character(posTrans_1$seqnames[i])
      chr2 = as.character(posTrans_2$seqnames[i])
      rearrangement = .execTranslocation(genome[[chr1]], genome[[chr2]], chr1, chr2, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, i, bpSeqSize, bpFlankSize, percSNPs, indelProb, maxIndelSize)
      genome[[chr1]] = rearrangement[[1]]
      genome[[chr2]] = rearrangement[[2]]
      posDel = rearrangement[[3]]
      posIns_1 = rearrangement[[4]]
      posIns_2 = rearrangement[[5]]
      posInv = rearrangement[[6]]
      posDup = rearrangement[[7]]
      posTrans_1 = rearrangement[[8]]
      posTrans_2 = rearrangement[[9]]
     
      if(verbose==TRUE) setTxtProgressBar(pb, i)
      
    }
    if(verbose==TRUE) close(pb)
  }

  
  ## 3. insertions
  if(ins > 0){
    if(verbose==TRUE) message("Rearranging genome: Insertions")
    if(verbose==TRUE) pb = txtProgressBar(min = 0, max = ins, style = 3)
    for(i in 1:ins){
      chr1 = as.character(posIns_1$seqnames[i])
      chr2 = as.character(posIns_2$seqnames[i])      
      rearrangement = .execInsertion(genome[[chr1]], genome[[chr2]], chr1, chr2, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, i, bpSeqSize, bpFlankSize, percSNPs, indelProb, maxIndelSize)
      genome[[chr1]] = rearrangement[[1]]
      genome[[chr2]] = rearrangement[[2]]
      posDel = rearrangement[[3]]
      posIns_1 = rearrangement[[4]]
      posIns_2 = rearrangement[[5]]
      posInv = rearrangement[[6]]
      posDup = rearrangement[[7]]
      posTrans_1 = rearrangement[[8]]
      posTrans_2 = rearrangement[[9]]
     
      if(verbose==TRUE) setTxtProgressBar(pb, i)
      
    }
    if(verbose==TRUE) close(pb)
  }
  
  ## 4. tandem duplications
  if(dups > 0){
    if(verbose==TRUE) message("Rearranging genome: Tandem duplications")
    ## add a column for the number of duplications
    tandemDups = cbind(tandemDups[, c("Name", "Chr", "Start","End", "Size")], 0, "")
    names(tandemDups) = c("Name", "Chr", "Start","End", "Size", "Duplications", "BpSeq")
    if(verbose==TRUE) pb = txtProgressBar(min = 0, max = dups, style = 3)
    for(i in 1:dups){
#      times = sample(2:maxDups,1)  ## how many times the sequence is duplicated
 	  times = dupTimes[i]
      chr = as.character(posDup$seqnames[i])
      rearrangement = .execTandemDuplication(genome[[chr]], chr, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, bpSeqSize, times, i, bpFlankSize, percSNPs, indelProb, maxIndelSize)
      genome[[chr]] = rearrangement[[1]]
      posDel = rearrangement[[2]]
      posIns_1 = rearrangement[[3]]
      posIns_2 = rearrangement[[4]]
      posInv = rearrangement[[5]]
      posDup = rearrangement[[6]]
      posTrans_1 = rearrangement[[7]]
      posTrans_2 = rearrangement[[8]]      
      tandemDups$BpSeq[i] = rearrangement[[9]]
      tandemDups$Duplications[i] = times
     
      if(verbose==TRUE) setTxtProgressBar(pb, i)
      
    }
    if(verbose==TRUE) close(pb)
  }

  ## 5. deletions
  if(dels > 0){
    if(verbose==TRUE) message("Rearranging genome: Deletions")
    if(verbose==TRUE) pb = txtProgressBar(min = 0, max = dels, style = 3)
    for(i in 1:dels){
      chr = as.character(posDel$seqnames[i])
      rearrangement = .execDeletion(genome[[chr]], chr, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, bpSeqSize, i, bpFlankSize, percSNPs, indelProb, maxIndelSize)
      genome[[chr]] = rearrangement[[1]]
      posDel = rearrangement[[2]]
      posIns_1 = rearrangement[[3]]
      posIns_2 = rearrangement[[4]]
      posInv = rearrangement[[5]]
      posDup = rearrangement[[6]]
      posTrans_1 = rearrangement[[7]]
      posTrans_2 = rearrangement[[8]]
     
      if(verbose==TRUE) setTxtProgressBar(pb, i)
      
    }
    if(verbose==TRUE) close(pb)
  }

  ## Retrieve breakpoint sequences for translocations, deletions and inversions (for duplications, it works during execution)
  if(invs > 0){
    inversions$BpSeq_5prime = inversions$BpSeq_3prime = ""
    for(i in 1:invs){
      bpSeq = .getBpSeq(genome, posInv, bpSeqSize, i)
      inversions$BpSeq_5prime[i] = bpSeq[1]
      inversions$BpSeq_3prime[i] = bpSeq[2]
    }
  }

  if(dels > 0){
    deletions$BpSeq = ""
    for(i in 1:dels){
      pos = posDel
      pos$end = pos$start
      bpSeq = .getBpSeq(genome, pos, bpSeqSize, i)
      deletions$BpSeq[i] = bpSeq[1]
    }
  }
  
  if(trans > 0){
    translocations$BpSeqB = translocations$BpSeqA = ""
    for(i in 1:trans){
      if(posTrans_1$balanced[i] == TRUE){
        bpSeq = .getBpSeq(genome, posTrans_1, bpSeqSize, i)
        translocations$BpSeqA[i] = bpSeq[which(bpSeq != "")][1]
      }
      bpSeq = .getBpSeq(genome, posTrans_2, bpSeqSize, i)
      translocations$BpSeqB[i] = bpSeq[which(bpSeq != "")][1]
    }
  }
  if(ins > 0){
    insertions$BpSeqB_3prime = insertions$BpSeqB_5prime = insertions$BpSeqA = ""
    for(i in 1:ins){
      if(posIns_1$copied[i] == FALSE){
        bpSeq = .getBpSeq(genome, posIns_1, bpSeqSize, i)
        insertions$BpSeqA[i] = bpSeq[1]
      }
      bpSeq = .getBpSeq(genome, posIns_2, bpSeqSize, i)
      insertions$BpSeqB_5prime[i] = bpSeq[1]
      insertions$BpSeqB_3prime[i] = bpSeq[2]
    }
  }

  ## Output ############################################################
  if(!is.na(output)){
    if(output == "."){
      if(verbose==TRUE) message("Writing output to current directory")
    }else{
      if(verbose==TRUE) message("Writing output to ", output)
    }
    
    if(dels > 0){
      write.table(deletions, file.path(output, "deletions.csv"), col.names=TRUE, row.names=FALSE, sep="\t", quote=FALSE)
    }
    if(ins > 0){
      write.table(insertions, file.path(output, "insertions.csv"), col.names=TRUE, row.names=FALSE, sep="\t", quote=FALSE)
    }
    if(invs > 0){
      write.table(inversions, file.path(output, "inversions.csv"), col.names=TRUE, row.names=FALSE, sep="\t", quote=FALSE)
    }
    if(dups > 0){
      write.table(tandemDups, file.path(output, "tandemDuplications.csv"), col.names=TRUE, row.names=FALSE, sep="\t", quote=FALSE)
    }
    if(trans > 0){
      write.table(translocations, file.path(output, "translocations.csv"), col.names=TRUE, row.names=FALSE, sep="\t", quote=FALSE)
    }
    
    writeXStringSet(genome, file.path(output, "genome_rearranged.fasta"), append=FALSE, format="fasta")
  }
  
  idx = c(dels>0, ins>0, invs>0, dups>0, trans>0)

  ##  names(svs) = c("deletions", "insertions", "inversions","tandemDuplications","translocations")[idx]
  metadata(genome) = list(deletions=deletions, insertions=insertions, inversions=inversions, tandemDuplications=tandemDups, translocations=translocations)[idx]
  
  return(genome)
  
})


.validateInput <- function(output, genome, chrs, dels, ins, invs, dups, trans, sizeDels, sizeIns, sizeInvs, sizeDups, regionsDels, regionsIns, regionsInvs, regionsDups, regionsTrans, maxDups, percCopiedIns, percBalancedTrans, percSNPs, indelProb, weightsMechanisms, weightsRepeats, bpSeqSize, random, seed){

  ## output
  if(!is.na(output)){
    if(!file.exists(output)){
      stop("Output directory does not exist")
    }
  }
  ## genome and chrs
  if(!missing(genome)){
    if(class(genome) == "DNAStringSet"){
      if(is.null(names(genome))){
        stop("Please enter chromosome names in your genome DNAStringSet")
      }
      if(!missing(chrs)){
        if(!all(chrs %in% names(genome))){
          stop("Invalid argument: Specified chromosomes and chromosome names in the genome do not match")
        }
      }
    }
    if(class(genome) == "BSgenome"){
      stop("Please extract the desired sequences from the BSgenome package and combine them into a named DNAStringSet")
    }
  }

  ## Number and size of SVs
  if(any(c(dels, ins, invs, dups, trans, sizeDels, sizeIns, sizeInvs, sizeDups) < 0)){
    stop("Invalid argument: Number of SVs and their size cannot be smaller than zero. Makes sense, doesn't it?")
  }
  
  ## percBalancedTrans, percCopiedIns, percSNPs, indelProb
  if(percBalancedTrans < 0 | percBalancedTrans > 1 | percCopiedIns < 0 | percCopiedIns > 1 | percSNPs < 0 | percSNPs > 1 | indelProb < 0 | indelProb > 1){
    stop("Invalid argument: Percentages have to be given as value between 0 and 1.")
  }

  ## random and regions
  if(length(random) != 1 & length(random) != 5){
    stop("Invalid argument: Give either one value for argument random for all SVs or five values for each SV in this order: deletions, insertions, inversions, tandem duplications, translocations")
  }
  if(random[1] == FALSE & missing(regionsDels)){
    stop("Missing argument: Please specifiy the regions for deletions")
  }
  if(random[2] == FALSE & missing(regionsIns)){
    stop("Missing argument: Please specifiy the regions for insertions")
  }
  if(random[3] == FALSE & missing(regionsInvs)){
    stop("Missing argument: Please specifiy the regions for inversions")
  }
  if(random[4] == FALSE & missing(regionsDups)){
    stop("Missing argument: Please specifiy the regions for tandem duplications")
  }
  if(random[5] == FALSE & missing(regionsTrans)){
    stop("Missing argument: Please specifiy the regions for translocations")
  }
  
  ## regions
  if(!missing(regionsIns) & random[2] == FALSE){
    if(!all(c("chrB","startB") %in% colnames(mcols(regionsIns)))){
      stop("Invalid argument: regionsIns is missing columns chrB and startB")
    }
  }
  if(!missing(regionsTrans) & random[5] == FALSE){
    if(!all(c("chrB","startB","endB") %in% colnames(mcols(regionsTrans)))){
      stop("Invalid argument: regionsTrans is missing columns chrB, startB and endB")
    }
  }

  ## repeat weights
  mechanisms = c("NAHR","NHR","TEI","VNTR","Other")
  bpTypes = c("L1","L2","Alu","MIR","SD","TR","Random")
  svTypes = c("dels", "invs", "ins", "dups", "trans")
  if(!missing(weightsMechanisms)){
    if(is.data.frame(weightsMechanisms)){
      if(!all(rownames(weightsMechanisms) %in% mechanisms) | !all(colnames(weightsMechanisms) %in% svTypes)){
        stop("Invalid argument: Please make sure that the row names of parameter weightsMechanisms equal \"NAHR\",\"NHR\",\"TEI\",\"VNTR\" and the column names equal \"Other\"\"dels\", \"invs\", \"ins\", \"dups\", \"trans\".")
      }
    }
  }
  if(!missing(weightsRepeats)){
    if(is.data.frame(weightsRepeats)){
        if(!all(rownames(weightsRepeats) %in% bpTypes) | !all(colnames(weightsRepeats) %in% mechanisms)){
          stop("Invalid argument: Please make sure that the row names of parameter weightsRepeats equal \"L1\",\"L2\",\"Alu\",\"MIR\",\"SD\",\"TR\",\"Random\" and the column names equal \"NAHR\",\"NHR\",\"TEI\",\"VNTR\",\"Other\".")
        }
    }    
  }

}


## Deprecated: Transposons (maybe useful for future release)
#
#    if(trans[3] > 0){
#      ## 1.3 for intra-chromosomal translocations
#    
#      message("Calculating coordinates: ", trans[3], " intra-chromosomal translocations")  
#      
#      intrachrom=TRUE
#      subtrahend = RangedData(rbind(gaps[, c("space","start","end")], posTrans_1[, c("space","start","end")], posTrans_2[, c("space","start","end")]))
#      regionsTrans  = .subtractIntervals(regionsTrans, subtrahend)
#      t = .simTranslocationPositions(trans[3], regionsTrans, genome, percInvertedTrans, percBalancedTrans, sizeTrans2, "intrachrom")
#      translocations = rbind(translocations, t[[1]])
#      posTrans_1 = rbind(posTrans_1, t[[2]])
#      posTrans_2 = rbind(posTrans_2, t[[3]])
#    }


## Maybe add gene annotation in future release (if it makes sense)
#    require(biomaRt)
#    ensembl=useMart("ensembl")
#    dataset="hsapiens_gene_ensembl"
#    ensembl=useDataset(dataset, mart=ensembl)
#    bmAttributes = c(
#      "hgnc_symbol",
#      "chromosome_name",  
#      "start_position",
#      "end_position"
#      )
#    bmFilter=c("chromosomal_region")
#    bmValues = as.list(paste(substr(d$Chr, 4, nchar(d$Chr)), d$Start, d$End, sep=":"))
#    genes = getBM(attributes=bmAttributes, filter=bmFilter, values=bmValues, mart=ensembl)
#    d$Genes = ""
#    for(i in 1:nrow(d)){
#      gene_overlap = subset(genes, (chromosome_name == substr(d$Chr[i], 4, nchar(d$Chr))) & (IRanges(start_position, end_position) %in% IRanges(d$Start[i], d$End[i])) & hgnc_symbol != "")
#      d$Genes[i] = paste(unique(gene_overlap$hgnc_symbol), collapse=",")
#    }

## calculate SV breakpoint coordinates #################################################

.drawPos <- function(chr, bpRegionsList, weightsMechanisms, weightsRepeats, size){

  bpRegions = NULL
  sampleChr = FALSE
  
  ## a chromosome can be given as single chromosome or vector (for translocations and insertions) or sampled randomly when set to NA (other SVs)
  if(any(is.na(chr))){
    sampleChr = TRUE
    chrs = seqlevels(bpRegionsList[["Random"]])
  }else{
    if(length(chr) > 1){
      sampleChr = TRUE
      chrs = chr      
    }else{
      chrs = seqlevels(bpRegionsList[["Random"]])
    }
  }

  ## sample mechanism
  idx = weightsMechanisms[,1] > 0  # col-index is 1, because main function already passed the right subset of weights
  mechanism = sample(rownames(weightsMechanisms)[idx], 1, prob=weightsMechanisms[idx,1])
  weightsRepeats = weightsRepeats[, mechanism, drop=FALSE]
  ## sample region type (kind of repeat or any other region)
  idx = weightsRepeats > 0
  regionType = sample(rownames(weightsRepeats)[idx], 1, prob=weightsRepeats[idx, 1])
  
  ## while loop in case there no suitable bpregion can be found within any chromosome
  while(length(bpRegions) == 0 & length(chrs) > 0){
    
    ## sample chromosome if it is missing; larger chromosomes have a higher probability
    if(sampleChr == TRUE){
      probs = sapply(chrs, function(x){return(sum(width(bpRegionsList[["Random"]][seqnames(bpRegionsList[["Random"]]) == x])))})
      if(all(probs == 0)){
        stop("Sorry, not possible to find a spot on the genome which is large enough for SV of size ", size, "bp, given the current parameter settings.")
      }
      chr = sample(chrs, 1, prob=probs)
      chrs = chrs[chrs != chr]
    }
    
    bpRegions = bpRegionsList[[regionType]]
    bpRegions = bpRegions[seqnames(bpRegions) == chr]
    
    if(regionType != "Random"){
      
      ## for NAHR, set the breakpoints within a repeat (plus some tolerance towards the repeat margins)
      ## make sure the regions do not overlap with valid "normal" regions
      if(mechanism == "NAHR"){
        tol = -50
        bpRegions = bpRegions[width(bpRegions) > size-(tol*2)]
      }
      ## for NHR, TEI and VNTR set at least one of both breakpoints within the repeats
      ## add some tolerance to the ends of the repeats and make sure the repeat will overlap the SV by at least 75%
      if(mechanism %in% c("NHR", "TEI", "VNTR")){
        tol = size*0.25
        bpRegions = bpRegions[width(bpRegions) > size*0.75]  # take care, that repeat will make up at least 75% of the SV region
      }
      ## for any "other" mechanism just use the regions itself;  select only those which are large enough
      if(mechanism == "Other"){
        tol = 0
        bpRegions = bpRegions[width(bpRegions) > size]
      }
      ## take care, that the region is free and available, i.e. not occupied by another SV
      if(length(bpRegions) > 0){
        bpRegions = bpRegions + tol
        bpRegions = bpRegions[queryHits(findOverlaps(bpRegions, bpRegionsList[["Random"]], type="within"))]
      }
      
    ## for any normal/random region just use the regions itself; select only those which are large enough
    }else{
      bpRegions = bpRegions[width(bpRegions) >= size]
    }
    
    ## in case there is no repeat region large enough, try another chromosome or set the breakpoint randomly (of only one left)
    if(length(bpRegions) == 0){
      if(length(chrs) == 1){
        regionType = "Random"
      }
    }
    
  }

  ## abort, if there is no regions large enough for this SV, no matter which mechanism you choose
  if(length(bpRegions) == 0){
    stop("Sorry, not possible to find a spot on the genome, which is large enough for SV of size ", size, "bp, given the current parameter settings.")
  }
    
  ## randomly select a region (larger regions have higher probability)
  idx = sample(x=1:length(bpRegions), size=1, prob=width(bpRegions))
  ## randomly select start and end within the region (regions are already large enough)
  start = sample(x=start(bpRegions[idx]):(end(bpRegions[idx])-size+1), size=1)
  end =  start + size -1
  
  return(data.frame(seqnames=unique(seqnames(bpRegions)), start=start, end=end))
}


.drawPos_trans <- function(chr, genome, bpRegionsList, weightsMechanisms, weightsRepeats){  
 
  ## draw breakpoint position and set the start/end to the outmost coordinate (1 for 5', chromosome end for 3')
  pos = .drawPos(chr, bpRegionsList, weightsMechanisms, weightsRepeats, 1) ## here: size = 1 -> start = end
  
  ## choose start or end whether the start/end of translocation is closer to start/end of the genome
  center = round(length(genome[[chr]]) / 2) + 1
  if(nrow(pos) > 0){
    if(pos$end < center){
      pos$start = 1
    }else{
      pos$end = length(genome[[chr]])
    }
  }
  return(pos)
  
}


## 1. translocations  #####################################################################

.simTranslocationPositions <- function(n, bpRegionsList, weightsMechanisms, weightsRepeats, genome, percBalancedTrans, sizes, verbose){
  
  posTrans_1 = .getDummyDataframe()
  posTrans_2 = .getDummyDataframe()
#  translocations = data.frame(Type="",ChrA=0,StartA=0,EndA=0,ChrB=0,StartB=0,EndB=0,Balanced=FALSE,BpSeqA_5prime="",BpSeqA_3prime="",BpSeqB_5prime="",BpSeqB_3prime="", stringsAsFactors=FALSE)[-1, ]
  invertedTrans = c()

  if(n > 0){
    
    if(verbose==TRUE) pb = txtProgressBar(min = 0, max = n, style = 3)
    
    for(i in 1:n){
      
      ## first translocation partner
      ## sample chromosome; larger chromosomes have a higher probability
      chrs = seqlevels(bpRegionsList[["Random"]])
      probs = sapply(chrs, function(x){return(sum(width(bpRegionsList[["Random"]][seqnames(bpRegionsList[["Random"]]) == x])))})
      chr1 = as.character(sample(chrs, 1, prob=probs))
      
      pos1 = .drawPos_trans(chr1, genome, bpRegionsList, weightsMechanisms, weightsRepeats)
      posTrans_1 = rbind(posTrans_1, pos1)
      
      ## make sure new SVs do not overlap with this one
      ## to do this, remove the half of the genome where the sv lies on
      pos = GRanges(IRanges(pos1$start, pos1$end), seqnames=pos1$seqnames)
      center = round(length(genome[[chr1]]) / 2) + 1
      if(start(pos) == 1){
        end(pos) = center
      }else{
        start(pos) = center
      }
      bpRegionsList[["Random"]] = .subtractIntervals(bpRegionsList[["Random"]], pos)

      ## second translocation partner
      chrs = chrs[chrs != chr1] # make sure second translocated segments lies on different chromosome
      probs = sapply(chrs, function(x){return(sum(width(bpRegionsList[["Random"]][seqnames(bpRegionsList[["Random"]]) == x])))})
      chr2 = as.character(sample(chrs, 1, prob=probs))
      
      pos2 = .drawPos_trans(chr2, genome, bpRegionsList, weightsMechanisms, weightsRepeats)
      posTrans_2 = rbind(posTrans_2, pos2)
      
      ## make sure new SVs do not overlap with this one
      ## to do this, remove the half of the genome where the sv lies on
      pos = GRanges(IRanges(pos2$start, pos2$end), seqnames=pos2$seqnames)
      center = round(length(genome[[chr2]]) / 2) + 1
      if(start(pos) == 1){
        end(pos) = center
      }else{
        start(pos) = center
      }
      bpRegionsList[["Random"]] = .subtractIntervals(bpRegionsList[["Random"]], pos)
      
      ## always invert translocated segments between different ends (5'<->3' or 3'<->5')
      if((pos1$start == 1 & pos2$start != 1) | (pos1$start != 1 & pos2$start == 1)){
        invertedTrans = c(invertedTrans, i)
      }
      
      if(verbose==TRUE) setTxtProgressBar(pb, i)

    }
    
    pos = rbind(posTrans_1, posTrans_2)
    posTrans_1 = posTrans_1[,1:3]
    posTrans_2 = posTrans_2[,1:3]
    
    if(verbose==TRUE) close(pb)
    
    ## randomly select translocations to be balanced
    balancedTrans = sample(1:n, round(n*percBalancedTrans))  ## indices of balanced translocations
    posTrans_1$balanced = FALSE
    posTrans_1$balanced[balancedTrans] = TRUE
    posTrans_2$balanced = posTrans_1$balanced

    posTrans_1$inverted = FALSE
    posTrans_1$inverted[invertedTrans] = TRUE
    posTrans_2$inverted = posTrans_1$inverted
    
    ## requires: balanced is the same for both translocation partners
    size1 = posTrans_1[, 3]-posTrans_1[, 2]+1
    size2 = posTrans_2[, 3]-posTrans_2[, 2]+1
    translocations = cbind("", posTrans_1[, 1:3], size1, posTrans_2[, 1:3], size2, posTrans_2[, "balanced"])
    colnames(translocations) = c("Name", "ChrA", "StartA", "EndA", "SizeA", "ChrB", "StartB", "EndB", "SizeB", "Balanced")
    translocations$Name = paste("translocation_", 1:n, sep="")

  }

  return(list(translocations, posTrans_1, posTrans_2))
}

## 2. insertions  #####################################################################

.simInsertionPositions <- function(n, bpRegionsList, weightsMechanisms, weightsRepeats, genome, sizes, percCopiedIns, verbose){
  
  posIns_1 = .getDummyDataframe()
  posIns_2 = .getDummyDataframe()

  if(n > 0){
    if(verbose==TRUE) pb = txtProgressBar(min = 0, max = n, style = 3)
    for(i in 1:n){
      ## first translocation partner
      chrs = seqlevels(bpRegionsList[["Random"]])      
      pos1 = .drawPos(chrs, bpRegionsList, weightsMechanisms, weightsRepeats, sizes[i])
      chr1 = pos1$seqnames
      posIns_1 = rbind(posIns_1, pos1)
      
      ## make sure new SVs do not overlap with this one
      bpRegionsList[["Random"]] = .subtractIntervals(bpRegionsList[["Random"]], GRanges(IRanges(pos1$start, pos1$end), seqnames=pos1$seqnames))
      
      ## second translocation partner
      ##chrs = chrs[chrs != chr1] # make sure second translocated segments lies on different chromosome (deprecated: intra-chromosomal insertions allowed)
      pos2 = .drawPos(chrs, bpRegionsList, weightsMechanisms, weightsRepeats, sizes[i])
      posIns_2 = rbind(posIns_2, pos2)
      
      ## make sure new SVs do not overlap with this one
      bpRegionsList[["Random"]] = .subtractIntervals(bpRegionsList[["Random"]], GRanges(IRanges(pos2$start, pos2$end), seqnames=pos2$seqnames))
      
      if(verbose==TRUE) setTxtProgressBar(pb, i)
    }
    pos = rbind(posIns_1, posIns_2)
    posIns_1 = posIns_1[,1:3]
    posIns_2 = posIns_2[,1:3]
    
    ## randomly select insertions to be copied
    copiedIns = sample(1:n, round(n*percCopiedIns))  ## indices of copied translocations
    posIns_1$copied = FALSE
    posIns_1$copied[copiedIns] = TRUE
    posIns_2$copied = posIns_1$copied
  
    ## requires: inverted and balanced are the same for both translocation partners
    insertions = cbind(paste("insertion_", 1:n, sep=""), posIns_1[, 1:3], posIns_2[, 1:3], sizes, posIns_2[, "copied"])
    colnames(insertions) = c("Name", "ChrA", "StartA", "EndA", "ChrB", "StartB", "EndB", "Size", "Copied")
    
  }

  if(verbose==TRUE) close(pb)

  return(list(insertions, posIns_1, posIns_2))
}  


## 3.  deletions, inversions and tandem duplications #################################
.simPositions <- function(n, bpRegionsList, weightsMechanisms, weightsRepeats, sizes, type, verbose){
  
  pos = .getDummyDataframe()

  if(n > 0){
    if(verbose==TRUE) pb = txtProgressBar(min = 0, max = n, style = 3)
    for(i in 1:n){      
  
      p = .drawPos(NA, bpRegionsList, weightsMechanisms, weightsRepeats, sizes[i])
      pos = rbind(pos, p)
      bpRegionsList[["Random"]] = .subtractIntervals(bpRegionsList[["Random"]], GRanges(IRanges(p$start, p$end), seqnames=p$seqnames))

      if(verbose==TRUE) setTxtProgressBar(pb, i)
    }
    svs = cbind("", pos, 0)
    colnames(svs) = c("Name", "Chr", "Start","End", "Size")
    svs$Size = sizes
    svs$Name = paste(type, 1:n, sep="")

  }
  
  if(verbose==TRUE) close(pb)

  pos = pos[, 1:3]

  return(list(svs, pos))
}

setGeneric("simulateSV",
           function(output=".", genome, chrs, dels=0, ins=0, invs=0, dups=0, trans=0, size, sizeDels=10, sizeIns=10, sizeInvs=10, sizeDups=10, regionsDels, regionsIns, regionsInvs, regionsDups, regionsTrans, maxDups=10, percCopiedIns=0, percBalancedTrans=1, bpFlankSize=20, percSNPs=0, indelProb=0, maxIndelSize=10, repeatBias=FALSE, weightsMechanisms, weightsRepeats, repeatMaskerFile, bpSeqSize=100, random=TRUE, seed, verbose=TRUE) {
             standardGeneric("simulateSV")
           })

setGeneric("estimateSVSizes",
           function(n, svSizes, minSize=NA, maxSize=NA, default="deletions", hist=TRUE){
             standardGeneric("estimateSVSizes")
           })

setGeneric("compareSV",
           function(querySVs, simSVs, tol=200){
             standardGeneric("compareSV")
           })

.addBreakpointMutations <- function(region, percSNPs, indelProb, maxIndelSize){

  regionSize = length(region)
  adjustBy = 0

  if(regionSize > 3 & percSNPs > 0){
    ## place SNPs
    idx = sample(x=c(TRUE,FALSE), size=regionSize, replace=TRUE, prob=c(percSNPs, 1-percSNPs))
    region = replaceLetterAt(region, idx, sample(x=c("A","C","G","T"), size=sum(idx), replace=TRUE))
  }
  
  if(regionSize > 3 & indelProb > 0){
    ## place maximum one indel into each region (50/50 if deletion or insertion)
    type = sample(c("del","ins"), 1)
    doIndel = sample(c(TRUE, FALSE), 1, prob=c(indelProb, 1-indelProb))
    if(doIndel & type == "del"){
      start = sample(1:(regionSize-maxIndelSize), 1)
      end = start + sample(1:maxIndelSize, 1)-1
      region = DNAString(paste(subseq(region, 1, start-1), subseq(region, end+1, length(region)), sep=""))
      adjustBy = adjustBy + (end-start+1)*(-1)
    }
    if(doIndel & type == "ins"){
      pos = sample(1:regionSize, 1)
      numNuc = sample(1:maxIndelSize, 1)
      insSeq = paste(sample(c("A","T","G","C"), numNuc, replace=TRUE), collapse="")
      region = DNAString(paste(subseq(region, 1, pos), insSeq, subseq(region, pos+1, length(region)), sep=""))
      adjustBy = adjustBy + numNuc
    }
  }

  return(list(region, adjustBy))

}

.execDeletion <- function(genomeSeq, c, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, bpSeqSize, i, bpFlankSize, percSNPs, indelProb, maxIndelSize){
  
  pos = posDel[i, ]
  start = as.integer(pos$start)
  end = as.integer(pos$end)

  ## add random mutations (SNPs an/or indels) at the breakpoints flanking regions (5' and 3')
  ## take care not to exceed the genome limits
  ## take care to adjust coordinates of other SVs correspondingly
  sf  = max(1, start-bpFlankSize)
  ef = min(length(genomeSeq), end+bpFlankSize)
  flankingRegion1 = subseq(genomeSeq, sf, start-1)
  flankingRegion2 = subseq(genomeSeq, end+1, ef)
  flankingRegion1 = .addBreakpointMutations(flankingRegion1, percSNPs, indelProb, maxIndelSize)
  adjustBy = flankingRegion1[[2]]
  flankingRegion1 = flankingRegion1[[1]]
  flankingRegion2 = .addBreakpointMutations(flankingRegion2, percSNPs, indelProb, maxIndelSize)
  adjustBy = adjustBy + flankingRegion2[[2]]
  flankingRegion2 = flankingRegion2[[1]]
  
  ## paste genome: fist part of chromosome - flanking bp region (5') - deleted region - flanking bp region (3') - rest of the chromosome
  genomeSeq = DNAString(paste(subseq(genomeSeq, 1, sf-1), flankingRegion1, flankingRegion2, subseq(genomeSeq, ef+1, length(genomeSeq)), sep=""))
  
  adjustBy = adjustBy + (end-start+1)*-1 # adjust positions by deletion size
  posDel = .adjustPositions(posDel, c, end, adjustBy)
  posIns_1= .adjustPositions(posIns_1, c, end, adjustBy)
  posIns_2= .adjustPositions(posIns_2, c, end, adjustBy)
  posInv = .adjustPositions(posInv, c, end, adjustBy)
  posDup = .adjustPositions(posDup, c, end, adjustBy)
  posTrans_1 = .adjustPositions(posTrans_1, c, end, adjustBy)
  posTrans_2 = .adjustPositions(posTrans_2, c, end, adjustBy)

  return(list(genomeSeq, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2))
}

.execInsertion <- function(genomeSeqA, genomeSeqB, c1, c2, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, i, bpSeqSize, bpFlankSize, percSNPs, indelProb, maxIndelSize){

  ## chrA
  pos = posIns_1[i, ]
  startA = as.integer(pos$start)
  endA = as.integer(pos$end)
  copied = pos$copied
  insSeq = subseq(genomeSeqA, startA, endA)
  
  ## remove or copy sequence on chrA
  if(copied == TRUE){
    ## nothing to do in this case
  }else{
    ## add random mutations (SNPs an/or indels) at the breakpoints flanking regions (5' and 3')
    ## take care not to exceed the genome limits
    ## take care to adjust coordinates of other SVs correspondingly
    sf  = max(1, startA-bpFlankSize)
    ef = min(length(genomeSeqA), endA+bpFlankSize)
    flankingRegion1 = subseq(genomeSeqA, sf, startA-1)
    flankingRegion2 = subseq(genomeSeqA, endA+1, ef)
    flankingRegion1 = .addBreakpointMutations(flankingRegion1, percSNPs, indelProb, maxIndelSize)
    adjustBy = flankingRegion1[[2]]
    flankingRegion1 = flankingRegion1[[1]]
    flankingRegion2 = .addBreakpointMutations(flankingRegion2, percSNPs, indelProb, maxIndelSize)
    adjustBy = adjustBy + flankingRegion2[[2]]
    flankingRegion2 = flankingRegion2[[1]]
    
    genomeSeqA = DNAString(paste(subseq(genomeSeqA, 1, sf-1), flankingRegion1, flankingRegion2, subseq(genomeSeqA, ef+1, length(genomeSeqA)), sep=""))
    ## adjust coordinates downstream of insertion
    ## (take care, that the end of ins1 is adjusted as well!)
    adjustBy = adjustBy + (endA-startA+1) * -1
    posIns_1$end[i] = posIns_1$start[i]
    posDel = .adjustPositions(posDel, c1, endA, adjustBy)
    posIns_1 = .adjustPositions(posIns_1, c1, endA, adjustBy)
    posIns_2 = .adjustPositions(posIns_2, c1, endA, adjustBy)
    posInv = .adjustPositions(posInv, c1, endA, adjustBy)
    posDup = .adjustPositions(posDup, c1, endA, adjustBy)
    posTrans_1 = .adjustPositions(posTrans_1, c1, endA, adjustBy)
    posTrans_2 = .adjustPositions(posTrans_2, c1, endA, adjustBy)
    ## update genome if insertion happens on the same chromosome
    if(c1 == c2){
     genomeSeqB = genomeSeqA
    }

  }  
  
  ## insert sequence from chrA into chrB
  pos = posIns_2[i, ]
  startB = as.integer(pos$start)
  endB = as.integer(pos$end)

  ## add random mutations (SNPs an/or indels) at the breakpoints flanking regions (5' and 3')
  ## take care not to exceed the genome limits
  ## take care to adjust coordinates of other SVs correspondingly
  sf  = max(1, startB-bpFlankSize)
  ef = min(length(genomeSeqB), startB+bpFlankSize-1)
  flankingRegion1 = subseq(genomeSeqB, sf, startB-1)
  flankingRegion2 = subseq(genomeSeqB, startB, ef)
  flankingRegion1 = .addBreakpointMutations(flankingRegion1, percSNPs, indelProb, maxIndelSize)
  adjustBy = flankingRegion1[[2]]
  flankingRegion1 = flankingRegion1[[1]]
  flankingRegion2 = .addBreakpointMutations(flankingRegion2, percSNPs, indelProb, maxIndelSize)
  adjustBy = adjustBy + flankingRegion2[[2]]
  flankingRegion2 = flankingRegion2[[1]]
  
  genomeSeqB = DNAString(paste(subseq(genomeSeqB, 1, sf-1),flankingRegion1, insSeq, flankingRegion2, subseq(genomeSeqB, ef+1, length(genomeSeqB)), sep=""))
    
  ## adjust coordinates downstream of insertion
  adjustBy = adjustBy + endA-startA+1
  posDel = .adjustPositions(posDel, c2, startB, adjustBy)
  posIns_1 = .adjustPositions(posIns_1, c2, startB, adjustBy)
  posIns_2 = .adjustPositions(posIns_2, c2, startB, adjustBy)
  posInv = .adjustPositions(posInv, c2, startB, adjustBy)
  posDup = .adjustPositions(posDup, c2, startB, adjustBy)
  posTrans_1 = .adjustPositions(posTrans_1, c2, startB, adjustBy)
  posTrans_2 = .adjustPositions(posTrans_2, c2, startB, adjustBy)
  ## update genome if insertion happens on the same chromosome
  if(c1 == c2){
    genomeSeqA = genomeSeqB
  }

  return(list(genomeSeqA, genomeSeqB, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2))
}

.execInversion <- function(genomeSeq, c, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, bpSeqSize, i, bpFlankSize, percSNPs, indelProb, maxIndelSize){
  
  pos = posInv[i, ]
  start = as.integer(pos$start)
  end = as.integer(pos$end)

  ## add random mutations (SNPs an/or indels) at the breakpoints flanking regions (5' and 3')
  ## take care not to exceed the genome limits
  ## take care to adjust coordinates of other SVs correspondingly
  sf  = max(1, start-bpFlankSize)
  ef = min(length(genomeSeq), end+bpFlankSize)
  flankingRegion1 = subseq(genomeSeq, sf, start-1)
  flankingRegion2 = subseq(genomeSeq, end+1, ef)
  flankingRegion1 = .addBreakpointMutations(flankingRegion1, percSNPs, indelProb, maxIndelSize)
  adjustBy = flankingRegion1[[2]]
  flankingRegion1 = flankingRegion1[[1]]
  flankingRegion2 = .addBreakpointMutations(flankingRegion2, percSNPs, indelProb, maxIndelSize)
  adjustBy = adjustBy + flankingRegion2[[2]]
  flankingRegion2 = flankingRegion2[[1]]

  invertedSeq = reverseComplement(subseq(genomeSeq, start, end))
  genomeSeq = DNAString(paste(subseq(genomeSeq, 1, sf-1), flankingRegion1, invertedSeq, flankingRegion2, subseq(genomeSeq, ef+1, length(genomeSeq)), sep=""))

  posDel = .adjustPositions(posDel, c, end, adjustBy)
  posIns_1= .adjustPositions(posIns_1, c, end, adjustBy)
  posIns_2= .adjustPositions(posIns_2, c, end, adjustBy)
  posInv = .adjustPositions(posInv, c, end, adjustBy)
  posDup = .adjustPositions(posDup, c, end, adjustBy)
  posTrans_1 = .adjustPositions(posTrans_1, c, end, adjustBy)
  posTrans_2 = .adjustPositions(posTrans_2, c, end, adjustBy)

  return(list(genomeSeq, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2))
}

.execTandemDuplication <- function(genomeSeq, c, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, bpSeqSize, times, i, bpFlankSize, percSNPs, indelProb, maxIndelSize){
  
  pos = posDup[i, ]
  start = as.integer(pos$start)
  end = as.integer(pos$end)

  ## add random mutations (SNPs an/or indels) at the breakpoints flanking regions (5' and 3')
  ## take care not to exceed the genome limits
  ## take care to adjust coordinates of other SVs correspondingly
  sf  = max(1, start-bpFlankSize)
  ef = min(length(genomeSeq), end+bpFlankSize)
  flankingRegion1 = subseq(genomeSeq, sf, start-1)
  flankingRegion2 = subseq(genomeSeq, end+1, ef)
  flankingRegion1 = .addBreakpointMutations(flankingRegion1, percSNPs, indelProb, maxIndelSize)
  adjustBy = flankingRegion1[[2]]
  flankingRegion1 = flankingRegion1[[1]]
  flankingRegion2 = .addBreakpointMutations(flankingRegion2, percSNPs, indelProb, maxIndelSize)
  adjustBy = adjustBy + flankingRegion2[[2]]
  flankingRegion2 = flankingRegion2[[1]]

  s = min(end-start+1, bpSeqSize)
  bpSeq = paste(subseq(genomeSeq, end-s+1, end), subseq(genomeSeq, start, start+s-1), sep="")
  dupSeq = subseq(genomeSeq, start, end)
  dupSeq = paste(rep(dupSeq, times + 1), collapse="")
  genomeSeq = DNAString(paste(subseq(genomeSeq, 1, sf-1), flankingRegion1, dupSeq, flankingRegion2, subseq(genomeSeq, ef+1, length(genomeSeq)), sep=""))
  
  adjustBy = adjustBy + (end-start+1)*(times) # adjust positions by length of additional sequence
  posDel = .adjustPositions(posDel, c, end, adjustBy)
  posIns_1= .adjustPositions(posIns_1, c, end, adjustBy)
  posIns_2= .adjustPositions(posIns_2, c, end, adjustBy)
  posInv = .adjustPositions(posInv, c, end, adjustBy)
  posDup = .adjustPositions(posDup, c, end, adjustBy)
  posTrans_1 = .adjustPositions(posTrans_1, c, end, adjustBy)
  posTrans_2 = .adjustPositions(posTrans_2, c, end, adjustBy)
  
  return(list(genomeSeq, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, bpSeq))
}

.execTranslocation <- function(genomeSeqA, genomeSeqB, c1, c2, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2, i, bpSeqSize, bpFlankSize, percSNPs, indelProb, maxIndelSize){
  
  ## chrA
  pos = posTrans_1[i, ]
  startA = as.integer(pos$start)
  endA = as.integer(pos$end)
  balanced = pos$balanced
  inverted = pos$inverted
  ## chrB
  pos = posTrans_2[i, ]
  startB = as.integer(pos$start)
  endB = as.integer(pos$end)

  ## eventually invert the translocated sequence (only when exchange between different ends; 5'<->3' or 3'<->5')
  if(inverted == TRUE){
    transSeqA = reverseComplement(subseq(genomeSeqA, startA, endA))
    transSeqB = reverseComplement(subseq(genomeSeqB, startB, endB))
  }else{
    transSeqA = subseq(genomeSeqA, startA, endA)
    transSeqB = subseq(genomeSeqB, startB, endB)
  }
  
  ## chrA ----> chrB
  
  ## add random mutations (SNPs an/or indels) at the breakpoints flanking regions (5' and 3')
  ## take care not to exceed the genome limits
  ## take care to adjust coordinates of other SVs correspondingly
  sf  = max(1, startB-bpFlankSize)
  ef = min(length(genomeSeqB), endB+bpFlankSize)
  flankingRegion1 = subseq(genomeSeqB, sf, startB-1)
  flankingRegion2 = subseq(genomeSeqB, endB+1, ef)
  flankingRegion1 = .addBreakpointMutations(flankingRegion1, percSNPs, indelProb, maxIndelSize)
  adjustBy = flankingRegion1[[2]]
  flankingRegion1 = flankingRegion1[[1]]
  flankingRegion2 = .addBreakpointMutations(flankingRegion2, percSNPs, indelProb, maxIndelSize)
  adjustBy = adjustBy + flankingRegion2[[2]]
  flankingRegion2 = flankingRegion2[[1]]
 
  genomeSeqB = DNAString(paste(subseq(genomeSeqB, 1, sf-1), flankingRegion1, transSeqA, flankingRegion2, subseq(genomeSeqB, ef+1, length(genomeSeqB)), sep=""))  
  
  ## adjust coordinates downstream of translocation
  ## (take care, that the end of trans1 is adjusted as well!)
  adjustBy = adjustBy + (endA-startA+1) - (endB-startB+1)
  posTrans_2$end[i] = posTrans_2$end[i] + adjustBy
  posDel = .adjustPositions(posDel, c2, endB, adjustBy)
  posIns_1 = .adjustPositions(posIns_1, c2, endB, adjustBy)
  posIns_2 = .adjustPositions(posIns_2, c2, endB, adjustBy)
  posInv = .adjustPositions(posInv, c2, endB, adjustBy)
  posDup = .adjustPositions(posDup, c2, endB, adjustBy)
  posTrans_1 = .adjustPositions(posTrans_1, c2, endB, adjustBy)
  posTrans_2 = .adjustPositions(posTrans_2, c2, endB, adjustBy)
  
  ## if balanced: chrA <---- chrB
  startA = as.integer(posTrans_1$start[i])
  endA = as.integer(posTrans_1$end[i])
 
  if(balanced == TRUE){

    ## add random mutations (SNPs an/or indels) at the breakpoints flanking regions (5' and 3')
    ## take care not to exceed the genome limits
    ## take care to adjust coordinates of other SVs correspondingly
    sf  = max(1, startA-bpFlankSize)
    ef = min(length(genomeSeqA), endA+bpFlankSize)
    flankingRegion1 = subseq(genomeSeqA, sf, startA-1)
    flankingRegion2 = subseq(genomeSeqA, endA+1, ef)
    flankingRegion1 = .addBreakpointMutations(flankingRegion1, percSNPs, indelProb, maxIndelSize)
    adjustBy = flankingRegion1[[2]]
    flankingRegion1 = flankingRegion1[[1]]
    flankingRegion2 = .addBreakpointMutations(flankingRegion2, percSNPs, indelProb, maxIndelSize)
    adjustBy = adjustBy + flankingRegion2[[2]]
    flankingRegion2 = flankingRegion2[[1]]
    
    genomeSeqA = DNAString(paste(subseq(genomeSeqA, 1, sf-1), flankingRegion1, transSeqB, flankingRegion2, subseq(genomeSeqA, ef+1, length(genomeSeqA)), sep=""))
    
    ## adjust coordinates downstream of balanced translocation
    adjustBy = adjustBy + (endB-startB+1) - (endA-startA+1)
  ## if not balanced: chrA <--NOT-- chrB
  }else{
    ## code for deleting the segment
    ## genomeSeqA = DNAString(paste(subseq(genomeSeqA, 1, startA-1), subseq(genomeSeqA, endA+1, length(genomeSeqA)), sep=""))    
    ## adjustBy = (endA-startA+1) * -1
    adjustBy = 0
  }
  ## adjust coordinates downstream of balanced translocation
  ## (take care, that the end of trans2 is adjusted as well!)
  posTrans_1$end[i] = posTrans_1$end[i] + adjustBy
  posDel = .adjustPositions(posDel, c1, endA, adjustBy)
  posIns_1 = .adjustPositions(posIns_1, c1, endA, adjustBy)
  posIns_2 = .adjustPositions(posIns_2, c1, endA, adjustBy)
  posInv = .adjustPositions(posInv, c1, endA, adjustBy)
  posDup = .adjustPositions(posDup, c1, endA, adjustBy)
  posTrans_1 = .adjustPositions(posTrans_1, c1, endA, adjustBy)
  posTrans_2 = .adjustPositions(posTrans_2, c1, endA, adjustBy)
  
  return(list(genomeSeqA, genomeSeqB, posDel, posIns_1, posIns_2, posInv, posDup, posTrans_1, posTrans_2))
}




## misc ################################################################

.adjustPositions <- function(pos, chr, beyondPos, adjustBy){
  idx = (pos$seqnames == chr) & (pos$start > beyondPos)
  if(any(idx)){
    pos$start[idx] = pos$start[idx] + adjustBy
    pos$end[idx] = pos$end[idx] + adjustBy
  }
  return(pos)
}
  
.getBpSeq <- function(genome, pos, bpSeqSize, i){
  pos = pos[i, ]
  c = as.character(pos$seqnames)
  start = as.integer(pos$start)
  end = as.integer(pos$end)
  seq =  genome[[c]]
  bpSeq = vector(mode="character", length=2)
  ## no 5' breakpoint sequences for svs at the beginning of the genome (terminal translocations)
  if(start == 1){
    bpSeq[1] = ""
  }else{
    s = max(1, start-bpSeqSize) ## take care that breakpoint sequence does not exceed the genome boundaries
    e = min(start+bpSeqSize-1, length(seq)) ## dito
    bpSeq[1] = as.character(subseq(seq, s, e))
  }
  ## no 3' breakpoint sequences for svs at the end of the genome (terminal translocations)
  if(end == length(seq)){
    bpSeq[2] = ""
  }else{
    s = max(1, end-bpSeqSize+1) ## take care that breakpoint sequence does not exceed the genome boundaries
    e = min(end+bpSeqSize, length(seq)) ## dito
    bpSeq[2] = as.character(subseq(seq, s, e))
  }
  return(bpSeq)
}
  

%\VignetteIndexEntry{RSVSim: an R/Bioconductor package for the simulation of structural variations}
%\VignettePackage{RSVSim}

\documentclass[10pt]{article}

\usepackage{times}
\usepackage{hyperref}

\textwidth=6.2in
\textheight=8.5in
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Rfunarg}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\Rcode}[1]{{\texttt{#1}}}

\SweaveOpts{prefix.string=RSVSim}

\begin{document}

\title{RSVSim \\ an R/Bioconductor package for the simulation of structural variations}
\author{Christoph Bartenhagen}
\date{\today}

\maketitle

\tableofcontents

<<echo=FALSE>>=
options(width=90)
options(continue=" ")
@


\section{Introduction}
The simulation of structural variations (SV) is an important measure to assess the performance of algorithms dealing with SVs and their detection and can help with the design of sequencing experiments. A simulation generates a base exact ground truth, which can be used to test the sensitivity and precision of SV callers. \\
A FASTA-file with the simulated, rearranged genome can be used by common, published read simulators (like \cite{art}), \cite{pirs}) to generate NGS datasets from various platforms that can then be used to asses an SV algorithm . A typical workflow consists of
\begin{center}
  SV simulation $\Rightarrow$ (Paired-End) Read simulation $\Rightarrow$ SV algorithm $\Rightarrow$ Evaluation\\
\end{center}
Varying parameters of the SV simulation like SV type, size or location and of the read simulator like number of reads (coverage), insert-size (for paired-end) or read length can give helpful information for future sequencing experiment designs. \\

This package addresses the very first step of SV simulation and provides the following features: \\
\begin{itemize}
  \item Simulation of deletions, insertions, inversions, tandem duplications and translocations (balanced and unbalanced) of various sizes
  \item Rearrangement of the human genome (hg19) by default or any other kind of genome available as FASTA file or \Rpackage{BSgenome} package
  \item Non-overlapping positioning of SV breakpoints within the whole genome or only a subset (e.g. coding, non-coding or low-complexity regions)
  \item Implementation of, e.g. previously detected or known, SVs at user-supplied coordinates
  \item Uniform distribution of SV breakpoints or simulation of biases towards repeat regions and regions of high homology according to different SV formation mechanisms (for hg19 only)
  \item Simulation of smaller mutations (SNPs and indels) close to the SV breakpoint
  \item Estimation of SV size distribution from real datasets
  \item Comparison of SV simulation with results from SV detection algorithms
\end{itemize}

\subsection{Loading the package}
After installation, the package can be loaded into R by typing 
<<preliminaries>>=
library(RSVSim)
@
into the R console. \\
\Rpackage{RSVSim} requires the R-packages \Rpackage{Biostrings}, \Rpackage{IRanges}, \Rpackage{GenomicRanges} and \Rpackage{ShortRead}. Mainly for efficient and convenient storing and access of sequences and genomic coordinates. The packages \Rpackage{BSgenome.Hsapiens.UCSC.hg19}, \Rpackage{GenomicFeatures}, \Rpackage{rtracklayer} and \Rpackage{MASS} are suggested for certain functionalities.

\section{Structural variation simulation}
The main function for simulation is called \Rpackage{simulateSV}. The simulation works pretty similar for every different SV type by specifying number and size of the variation(s) and (optionally) the regions, where to place the variation (randomly or not). The size can be either one value for every SV type or a vector of values for every single SV. \\
The following sections give a short example for every SV type using a simple toy example with two chromosomes of 40bp each:
<<label=toyExample, eval=TRUE>>=
genome = DNAStringSet(
c("AAAAAAAAAAAAAAAAAAAATTTTTTTTTTTTTTTTTTTT", 
"GGGGGGGGGGGGGGGGGGGGCCCCCCCCCCCCCCCCCCCC"))
names(genome) = c("chr1","chr2")
genome
@
The genome has to be a named \Robject{DNAStringSet} or a filename that points to a FASTA-file saved somewhere on disk. By default, when omitting the genome parameter, \Rfunction{simulateSV} will load the human genome (hg19) automatically. This requires an installation of the R-package \Rpackage{BSgenome.Hsapiens.UCSC.hg19}. \\
When using other \Rpackage{BSgenome} packages, it is recommended to extract the desired sequences first and combine them into a named \Rcode{DNAStringSet}. For example, the preparation of the genome of an Ecoli strain (str. 536) would look like:
<<label=genomeEcoli, eval=FALSE>>=
library(BSgenome.Ecoli.NCBI.20080805)
genome = DNAStringSet(Ecoli[["NC_008253"]])
names(genome) = "NC_008253"
@
Each implemented SV will be reported with its position in the "normal" reference genome, and the breakpoint sequences. The rearranged genome is returned as \Robject{DNAStringSet} and the SV information is stored in its \Rcode{metadata} slot as a named \Robject{list} of \Rcode{data.frames}. All this can also be written to disk by specifying an \Rfunarg{output} directory (which is the current directory by default). The SV tables are saved as CSV files (called deletions.csv, insertions.csv etc.) and the genome in FASTA format (genome\_rearranged.fasta). \\

Note, that the seeds for the randomizations in the following examples were set for demonstration purposes only. The \Rfunarg{seed} parameter can be omitted or used to reproduce the same simulation several times. \\
The parameter \Rfunarg{output} is set to \Rcode{NA} in all examples to avoid wrtiting the output to disc. The parameter \Rfunarg{verbose} is set to \Rcode{FALSE}  to suppress progress information about the simulation (which is enabled by default).

\subsection{Deletions}
A segment is cut out from the genome. The following example generates three deletions of 10bp each:

<<label=deletionExample, eval=TRUE, hide=TRUE>>=
sim = simulateSV(output=NA, genome=genome, dels=3, sizeDels=10,
bpSeqSize=6, seed=456, verbose=FALSE)
sim
metadata(sim)
@
Chromosome 2, which harbours two deletions, is now 10bp shorter than chromosome 1. The breakpoint sequence of 6bp shows the 3bp up- and downstream of the deletion breakpoint in the rearranged genome.

\subsection{Insertions}
A segment is cut or copied from one chromosome A and inserted into another chromosome B. The following example generates three insertions of 5bp each:
<<label=insertionExample, eval=TRUE, hide=TRUE>>=
sim = simulateSV(output=NA, genome=genome, ins=3, sizeIns=5, bpSeqSize=6,
seed=246, verbose=FALSE)
sim
metadata(sim)
@
Regarding insertion\_1, for example, the 5bp segment \Rcode{AAAAA} has been removed from chr1:14-18 and inserted into chr2:19-23. There are three breakpoint sequences reported for each insertion: the sequence at the deletion on chrA and at the 5' and 3' end of its insertion on chrB. \\

Setting the parameter \Rfunarg{percCopiedIns} (range: 0-1, i.e. 0\%-100\%) can change the amount of "copy-and-paste-like" insertions. \\
The same example as before, with the difference that two of the three inserted sequences are copied: 
<<label=insertionExample, eval=TRUE>>=
sim = simulateSV(output=NA, genome=genome, ins=3, sizeIns=5, percCopiedIns=0.66, 
bpSeqSize=6, seed=246, verbose=FALSE)
sim
metadata(sim)
@
The same sequence \Rcode{AAAAA} from insertion\_1 is now duplicated before insertion into chr2:19-23. Here, no breakpoint sequence is reported for the region on chr1, since this chromosome is not altered.

\subsection{Inversions}
A segment is cut from one chromosome and its reverse complement is inserted at the same place without loss or a shift of sequence. The example below assigns a different size for each inversion:
<<label=inversionExample, eval=TRUE>>=
sim = simulateSV(output=NA, genome=genome, invs=3, sizeInvs=c(2,4,6),
bpSeqSize=6, seed=456, verbose=FALSE)
sim
metadata(sim)
@
Inversions have two breakpoint sequences, one for the 5' end and one for the 3' end of the inverted segment.

\subsection{Tandem duplications}
A segment is duplicated one after the other. The number of duplications is determined randomly. The parameter \Rfunarg{maxDups} sets the maximum. The following example generates an, at most, tenfold tandem duplication of a 6bp sequence:
<<label=tandemDupExample, eval=TRUE>>=
sim = simulateSV(output=NA, genome=genome, dups=1, sizeDups=6, maxDups=3,
bpSeqSize=6, seed=3456, verbose=FALSE)
sim
metadata(sim)
@
Here, the breakpoint sequence is the sequence at the end of one duplicated segment and the start of the following one. In this example the duplicated sequence is \Rcode{AAATTT} and it has been repeated another two times.

\subsection{Translocations}
A segment from the 5' or 3' end of one chromosome A is exchanged with the 5' or 3' end of another chromosome B. If it is not balanced, the segment from chromosome B will be lost, what results in a duplicated sequence from chromosome A. The parameter \Rfunarg{percBalancedTrans} sets the amount of balanced translocation (0-1, i.e. 0\%-100\%); by default, all translocations will be balanced. Segments which are translocated between two different ends (5'$\leftrightarrow$'3' of 3'$\leftrightarrow$5') are always inverted. After random generation of the breakpoint, the translocation spans the chromosome until the closest of both ends (which may include the centromere in the human genome).
<<label=translocationExample1, eval=TRUE>>=
sim = simulateSV(output=NA, genome=genome,trans=1, bpSeqSize=6, seed=123, verbose=FALSE)
sim
metadata(sim)
@
This example exchanges the last 3bp of chromosome 2 with the first 19bp of chromosome 1. Both sequences were inverted.\\

The same example in an unbalanced fashion:
<<label=translocationExample1, eval=TRUE>>=
sim = simulateSV(output=NA, genome=genome,trans=1, percBalancedTrans=0,
bpSeqSize=6, seed=123, verbose=FALSE)
sim
metadata(sim)
@
The sequence from chr1:1-19 is lost, while there are now two copies of the translocated (inverted) segment from chr2:38-40. The breakpoint sequence for chr2 (denoted by chrA in general) is not reported, since this chromosome is not altered.

\section{Simulation of biases towards SV formation mechanisms and repeat regions}
By default, the SV breakpoints are placed uniformly across the genome. Several studies have shown, that structural variation formation in the human genome is not a random process but rather the result of mechanisms such as nonallelic homologous recombination (NAHR), nonhomologous recombination (NHR), variable number of tandem repeats (VNTRs) and transposable element insertions (TEIs) (\cite{1000genomes}, \cite{svformation2}). These mechanisms can be further associated with repeat elements and regions of high homology such as LINEs, SINEs, Micro-/Minisatellites and segmental duplications (\cite{svformation1}). \\
Using the default genome hg19 and setting \Rfunarg{repeatBias} to \Rcode{TRUE}, \Rpackage{RSVSim} simulates a bias of breakpoint positioning towards repeat regions. This is done in two steps: 
\begin{enumerate}
  \item Weighting SV formation mechanisms (here: NAHR, NHR, VNTR, TEI, Other) for each SV type. The type "Other" can be used for any individual weighting of repeats; by default, "Other" is associated with a random breakpoint.
  \item Weighting each SV formation mechanism for each kind of repeat. The following types of repeat regions are supported: LINE/L1, LINE/L2, SINE/Alu, SINE/MIR, segmental duplications (SD), tandem repeats (TR; mainly micro-/minisatellites) and Random. The latter, "Random", means any region on the genome.
\end{enumerate}
For the mechanism NAHR, both breakpoints will lie within a repeat region (with at least 50bp distance to the repeat margins), while for NHR, VNTR, TEI and Other, the repeat must make up for at least 75\% of the SV region. \\ This feature is turned off automatically, when the user specifies his own genome (i.e. any genome other than hg19). \\
The default weights for SV mechanisms for deletions, insertions an duplications are based on figure 4b in \cite{1000genomes}. The weights for inversions refer to figure 3c in \cite{svformation2}. The mechanisms and breakpoint sequences of translocations have not been studied as extensively as for other kinds of SVs. The default weights for translocations were chosen according to some exemplary publications (\cite{svformation3}, \cite{svformation4}), so that NAHR, NHR and random breakpoint positioning contribute equally. In all cases, the results for SVs $>$1.000bp were used. The exact weights are:
<<label=weightsMechanisms, eval=TRUE, echo=FALSE, hide=FALSE>>=
data(weightsMechanisms, package="RSVSim")
show(weightsMechanisms)
@
The default weights for repeat regions for every SV mechanism were based on the enrichment analysis in \cite{svformation1} (see their supplemental table 5). The exact values are:
<<label=weightsRepeats, eval=TRUE, echo=TRUE, hide=FALSE>>=
data(weightsRepeats, package="RSVSim")
show(weightsRepeats)
@
The user may provide other weights by passing his own \Rcode{data.frames}, using the function arguments \Rfunarg{weightsMechanisms} and \Rfunarg{weightsRepeats}. The structure of the \Rcode{data.frames} has to be identical to the default ones shown above (i.e. same dimensions, column and row names). The effect of the weights is comparable to the \Rfunarg{prob} argument in the R function \Rfunction{sample}. \\
For example
<<label=weightsExample, eval=FALSE, echo=FALSE, hide=FALSE>>=
weightsRepeats = data.frame(
  NAHR = c(0,0,3,1,0,0,0),
  NHR = c(1.04,0.62,1.16,0,2.06,0,0),
  TEI = c(1.66,0.25,0,0,0,0,0),
  VNTR = c(0,0,0,0,0,1,0),
  Other = c(0,0,0,0,0,0,1)
)
rownames(weightsRepeats) = c("L1","L2","Alu","MIR","SD","TR","Random")
sim = simulateSV(output=NA, dels=10, repeatBias=TRUE, weightsRepeats=weightsRepeats,
verbose=FALSE)
@
would exclude tandem repeats, segmental duplications and random regions from the simulation (except for VNTRs) by setting their weights to zero for all mechanisms. NAHRs, would be related to SINEs only. For \Rfunarg{weightsMechanisms}, the default values will be used, because the argument is missing here. Note, that \Rcode{repeatBias=TRUE} has to be set to use this feature. \\

This feature requires the coordinates of repeat regions for hg19. This can be handled in two ways: 
\begin{itemize}
  \item \Rpackage{RSVSim} downloads the coordinates once automatically from the UCSC Browser's RepeatMasker track (which may take up to 45 Minutes!).
  \item The user may specify the filename of a RepeatMasker output file downloaded from their homepage (\cite{repeatmasker}): http://www.repeatmasker.org/species/homSap.html (e.g. hg19.fa.out.gz). Loading this file takes only a few minutes.
\end{itemize}
In both cases, RSVSim saves the coordinates as \Rcode{RData} object \Rcode{repeats\_hg19.RData} to the RSVSim installation directory for a faster access in the future (if write privileges allow to do so). After that, one of the two steps mentioned above is not necessary anymore and next time, \Rpackage{RSVSim} is going to load the coordinates automatically from the \Rcode{RData} file. \\
When loading the repeats, neighboured ones with a distance up to 50bp will be merged, to obtain larger repeat regions and to allow SVs to span more than one repeat. But, breakpoints will only be placed within repeats of the same type (e.g. LINE/L1-LINE/L1, or SINE/MIR-SINE/MIR etc.).

\section{Simulation of additional breakpoint mutations}
SV breakpoints are usually not clean but tend to co-occur with other, usually smaller mutations, such as indels or SNPs. \Rpackage{RSVSim} allows to randomly generate additional SNPs and indels within the flanking regions of each breakpoint. Their generation can be configured by the four arguments \Rfunarg{bpFlankSize}, \Rfunarg{percSNPs}, \Rfunarg{indelProb} and \Rfunarg{maxIndelSize}, which specify the size of the flanking regions in bp (i.e. proximity of the mutations to the breakpoint), the fraction on SNPs (in \%), the probability of an indel (insertions and deletions are equally likely) and the maximum size of an indel (size is selected randomly between 1 and \Rfunarg{maxIndelSize}). Each flanking region may only contain one indel. SNPs can affect 0-100\% of the region. By default, this feature is turned off. \\
The following example creates one deletion with 10\% SNPs and 100\% indel probability within 10bp up-/downstream of the breakpoint:
<<label=bpMutationsExample, eval=TRUE>>=
sim = simulateSV(output=NA, genome=genome, dels=1, sizeDels=5, bpFlankSize=10, 
percSNPs=0.25, indelProb=1, maxIndelSize=3, bpSeqSize=10, seed=123, verbose=FALSE)
sim
metadata(sim)
@
In addition to the 5bp deletion of the sequence \Rcode{CCCCC}, two SNPs \Rcode{C$->$T} and \Rcode{C$->$A}, and a deletion of two more \Rcode{C}s were added up- and downstream of the breakpoint.

\section{Simulation within a genome subset}
It is possible to run the simulation to certain chromosomes only by specifying the chromosome names in the parameter \Rfunarg{chrs}. It has to be taken care that these chromosome names match the names in the \Robject{DNAStringSet} containing the genome sequences (e.g. "chr1", "chr2", ..., "chrY" for the default genome hg19 from the package \Rpackage{BSgenome.Hsapiens.UCSC.hg19}). \\
Furthermore, every SV has it's own parameter to restrict the simulation to a desired set of genomic regions: \Rfunarg{regionsDels}, \Rfunarg{regionsIns}, \Rfunarg{regionsInvs}, \Rfunarg{regionsDups} and \Rfunarg{regionsTrans}. Each one being a \Robject{GRanges} object with a chromosome name, start- and end-position. \\
The following example places randomly four inversions into the second half of chr1 and the first half of chr2:
<<label=regionsExample1, eval=TRUE>>=
regions = GRanges(IRanges(c(21,1),c(40,20)), seqnames=c("chr1","chr2"))
regions
sim = simulateSV(output=NA, genome=genome, invs=4, sizeInvs=5, 
regionsInvs=regions, bpSeqSize=6, seed=2345, verbose=FALSE)
sim
metadata(sim)
@
For translocations, the regions only say where to place the breakpoint, since the translocated region spans the chromosome until the closest of both ends. \\

Some applications may focus on certain parts of the hg19 only, like exons, introns or transcripts. The package \Rpackage{GenomicFeatures} provides functionalities to export such coordinates from the UCSC Genome Browser to R (see for example \Rfunction{makeTxDbFromUCSC}, \Rfunction{exonsBy}, \Rfunction{intronsBy}, \Rfunction{transcriptsBy}). In the following example, 100 deletions would be placed somewhere in the exonic regions on hg19:
<<label=regionsExample2, eval=FALSE>>=
transcriptDB = makeTxDbFromUCSC(genome = "hg19",tablename = "knownGene")
exons = exonsBy(transcriptDB)
exons = unlist(exons)
exons = GRanges(IRanges(start=start(exons), end=end(exons)), seqnames=seqnames(exons))
simulateSV(output=NA, dels=100, regionsDels=exons, sizeDels=1000, bpSeqSize=50)
@

SVs will not be placed within unknown regions or assembly gaps denoted by the letter \Rcode{N}. Such regions are detected and filtered automatically.

\subsection{Inserting a set of SVs}
The simulation allows to turn off the random generation of breakpoints and to insert a set of (for example previously detected or known) SVs. It works by using the same regions parameters and setting the parameter \Rfunarg{random} to \Rcode{FALSE}. This may also be a vector of five \Rcode{TRUE}/\Rcode{FALSE} values (in the order: deletions, insertions, inversions, tandem duplications, translocations) if some SVs shall be generated randomly and others not. \\
The example below inserts a deletion at chr2:16-25:
<<label=regionsExample3, eval=TRUE>>=
knownDeletion = GRanges(IRanges(16,25), seqnames="chr2")
names(knownDeletion) = "myDeletion"
knownDeletion
sim = simulateSV(output=NA, genome=genome, regionsDels=knownDeletion,
bpSeqSize=10, random=FALSE, verbose=FALSE)
sim
metadata(sim)
@
Note, that the output adopts the names, that were given the \Robject{GRanges} object of the inserted SV(s). \\

It's a little different for insertions and translocations, since they involve two genomic regions. Thus, the \Robject{GRanges} object for \Rfunarg{regionsIns} has to be extended by columns \Rcode{chrB} and \Rcode{startB}, saying, that the sequence within ranges of the \Robject{GRanges} object will be inserted at chrB:startB. \\
The next example inserts the sequence from chr1:16:25 at chr2:26:
<<label=regionsExample4, eval=TRUE>>=
knownInsertion = GRanges(IRanges(16,25),seqnames="chr1", chrB="chr2", startB=26)
names(knownInsertion) = "myInsertion"
knownInsertion
sim = simulateSV(output=NA, genome=genome, regionsIns=knownInsertion,
bpSeqSize=10, random=FALSE, verbose=FALSE)
sim
metadata(sim)
@
The \Robject{GRanges} object for translocations has to be extended by columns \Rcode{chrB}, \Rcode{startB} and \Rcode{endB}, saying, the sequence within the ranges of the object will be exchanged with the sequence from chrB:startB-endB. Typically, one start/end of each region equals the 5'or 3' end of the chromosome. One may add a column \Rcode{balanced} saying \Rcode{TRUE}/\Rcode{FALSE} for every single entry. \\
The next example is a simple simulation of the translocation t(9;22) leading to the BCR-ABL fusion gene. It uses simple breakpoints within 9q34.1 and 22q11.2 for demonstration:
<<label=regionsExample5a, eval=TRUE>>=
trans_BCR_ABL = GRanges(IRanges(133000000,141213431), seqnames="chr9", 
chrB="chr22", startB=23000000, endB=51304566, balanced=TRUE)
names(trans_BCR_ABL) = "BCR_ABL"
trans_BCR_ABL
@
<<label=regionsExample5b, eval=FALSE>>=
sim = simulateSV(output=NA, chrs=c("chr9", "chr22"), regionsTrans=trans_BCR_ABL,
bpSeqSize=50, random=FALSE)
@
The example is not executed here, because it requires the package \Rpackage{BSgenome.Hsapiens.UCSC.hg19}. Setting the argument \Rcode{transInsert=20} adds up to 20 random nucleotides at both breakpoints. \\

It is strongly recommended to only use a set of non-overlapping SVs.

\section{Comparing two sets of SVs}
A typical use case of SV simulation with is the evaluation of SV detection algorithms. The function \Rfunction{compareSV} looks for overlaps between the output of the simulation, the ground truth (\Rfunarg{simSVs}), and the output of an SV detection program (\Rfunarg{querySVs}) up to a certain tolerance. It computes the sensitivity, precision and the percentage overlap between the breakpoint sequences (if available). \\
An overlap is defined as the overlap between the breakpoints/breakpoint regions in \Rfunarg{simSVs}/\Rfunarg{querySVs} up to the given tolerance in bp. Overlap does not mean the whole affected region between the start and end of the SV. \\
Unfortunately, there is currently no common standard format for SVs. Because the main information about SVs is their position in the genome and, sometimes, the breakpoint sequence (which depends on the SV detection algorithm), \Rfunction{compareSV} expects the SV detections as tables in a simple BED- or BEDPE format (\url{http://code.google.com/p/bedtools}). Deletions, inversions and tandem duplications, which affect one region on the genome,  can be either given in both formats. Translocations and insertions, which affect to regions on the genome, require the BEDPE-format. Eventually, the output of the SV detection format has to be converted accordingly (for example in R). \\
The function only compares one SV type at a time, so \Rfunarg{querySVs} and \Rfunarg{simSVs} may not contain a mixture of different kinds of SVs. \\
If the BED-tables for \Rfunarg{querySVs} or the simulation output are saved on disk, \Rfunction{compareSV} also accepts their filenames and loads the tables automatically as \Rcode{data.frame} in R. \\

The following example simulates first five 5bp deletions in the small toy genome defined above: \\
<<label=comparisonExample1, eval=TRUE>>=
sim = simulateSV(output=NA, genome=genome, dels=5, sizeDels=5,
bpSeqSize=10, seed=2345, verbose=FALSE)
simSVs = metadata(sim)$deletions
simSVs
@
An SV detection in BED format (the \Rfunarg{querySVs}) may look like this: Four of five deletions were detected, two with exact and two with an approximate breakpoint. Two additional deletions were detected, which were not part of the simulation. 
<<label=comparisonExample2, eval=TRUE>>=
querySVs = data.frame(
  chr=c("chr1","chr1","chr1","chr2","chr2"),
  start=c(12,17,32,2,16), 
  end=c(15,24,36,6,20), 
  bpSeq=c("AAAAAAAAAA", "AAAAAAATTT", "TTTTTTTTTT", 
    "GGGGGGGGGG", "GGGGGGCCCC")
)
querySVs
@
The column with the breakpoint sequence is optional, the column names not important (BED-files have no header). \\
A comparison with 0bp tolerance yields only two overlaps:
<<label=comparisonExample3, eval=TRUE>>=
compareSV(querySVs, simSVs, tol=0)
@
A higher breakpoint tolerance of +/- 3bp also includes more imprecise detections:
<<label=comparisonExample4, eval=TRUE>>=
compareSV(querySVs, simSVs, tol=3)
@
Note that for \Rcode{deletion1}, the breakpoint sequence matched only by 80\%. \\

The second example compares translocations:
<<label=comparisonExample5, eval=TRUE>>=
sim = simulateSV(output=NA, genome=genome, trans=2, percBalancedTrans=0.5, 
bpSeqSize=10, seed=246, verbose=FALSE)
simSVs = metadata(sim)$translocations
simSVs
@
Detected translocations have to be given in BEDPE-format (i.e. at least six columns chr1, start1, end1, chr2, start2, end2 for the breakpoints on both chromosomes). In this example, the breakpoints were approximated up to 1bp or 2bp, optional breakpoint sequences are missing:
<<label=comparisonExample6, eval=TRUE>>=
querySVs = data.frame(
  chr=c("chr1", "chr1", "chr2"), 
  start1=c(15,32,32), 
  end1=c(18,36,33), 
  chr2=c("chr2","chr2","chr1"),
  start2=c(10,31,32),
  end2=c(12,33,36)
)
querySVs
@
Here, all detected SVs span the simulated breakpoints:
<<label=comparisonExample7, eval=TRUE>>=
compareSV(querySVs, simSVs, tol=0)
@

\section{Setting structural variation sizes}
One may specify just one size in the parameters \Rfunarg{sizeDels}, \Rfunarg{sizeIns}, \Rfunarg{sizeInvs} or \Rfunarg{sizeDups} that applies to every SV of each type. But often, it might be more realistic to assign an individual, arbitrary size to every single SV. In the simplest case, they may be uniformly distributed:
<<echo=FALSE>>=
set.seed(246)
@
<<label=sizesExample1, eval=TRUE>>=
sizes = sample(2:5, 5, replace=TRUE)
sizes
sim = simulateSV(output=NA, genome=genome, dels=5, sizeDels=sizes,
bpSeqSize=6, seed=246, verbose=FALSE)
sim
metadata(sim)
@
\subsection{Estimating size distribution from real data}
According to studies from the 1000 Genomes Project, for deletions, insertions and duplications, the amount of SVs decreases rather quickly as their size increases (\cite{1000genomes}). The function \Rfunction{estimateSVSizes} simulates SV sizes by fitting a beta distribution, which is flexible enough to realistically model the shape of the size distribution of all four SV types. Its two shape parameters can be derived from a given vector of SV sizes. This requires the R-package \Rpackage{MASS}.\\
The following toy example draws 1.000 SV sizes between 10bp and 1000bp from a beta distribution based on a  vector of 15 SV sizes:
<<label=sizesExample2, eval=TRUE,fig=TRUE,include=FALSE,eps=FALSE,pdf=TRUE,width=9,height=9>>=
svSizes = c(10,20,30,40,60,80,100,150,200,250,300,400,500,750,1000)
simSizes = estimateSVSizes(n=1000, svSizes=svSizes, minSize=10, maxSize=1000, hist=TRUE) 
head(simSizes, n=20)
@
The \Rfunarg{minSize} and \Rfunarg{maxSize} can be omitted; they are then calculated from the given set of \Rfunarg{svSizes}. It is recommended to uses a \Rfunarg{minSize} and \Rfunarg{maxSize} that is consistent with the minimum/maximum values in \Rfunarg{svSizes}. \\
Setting the parameter \Rcode{hist=TRUE} also plots a histogram of the SV sizes to give an impression of their distribution (see Fig.1).
\begin{figure}[p]
\begin{center}
  \includegraphics[height=9cm, width=9cm]{RSVSim-sizesExample2}
  \caption{Distribution of 1.000 SV sizes drawn from a beta distribution using function \Rfunction{estimateSVSizes}.}
\end{center}
\end{figure}

For deletions, insertions, inversions and tandem duplications, \Rfunction{estimateSVSizes} can use default parameters for the beta distribution. They were estimated from the Database of Genomic Variants (DGV) release 2012-03-29 (\cite{dgv}). Hence, no set of SV sizes is needed for fitting the distribution. In total, 1.129 deletions, 490 insertions, 202 inversions and 145 tandem duplications between 500bp and 10kb were used to estimate the shape. The parameter \Rfunarg{default} can be set to either \Rcode{"deletions"}, \Rcode{"insertions"}, \Rcode{"inversions"} or \Rcode{"tandemDuplications"} to use the according set of shape parameters:
<<label=sizesExample3, eval=TRUE,fig=TRUE,include=FALSE,eps=FALSE,pdf=TRUE,width=9,height=9>>=
delSizes = estimateSVSizes(n=10000, minSize=500, maxSize=10000, 
default="deletions", hist=TRUE)
head(delSizes, n=15)
@
<<label=sizesExample4, eval=TRUE,fig=TRUE,include=FALSE,eps=FALSE,pdf=TRUE,width=9,height=9>>=
delSizes = estimateSVSizes(n=10000, minSize=500, maxSize=10000, 
default="insertions", hist=TRUE)
head(delSizes, n=15)
@
<<label=sizesExample5, eval=TRUE,fig=TRUE,include=FALSE,eps=FALSE,pdf=TRUE,width=9,height=9>>=
invSizes = estimateSVSizes(n=10000, minSize=500, maxSize=10000, 
default="inversions", hist=TRUE)
head(invSizes, n=15)
@
<<label=sizesExample6, eval=TRUE,fig=TRUE,include=FALSE,eps=FALSE,pdf=TRUE,width=9,height=9>>=
delSizes = estimateSVSizes(n=10000, minSize=500, maxSize=10000, 
default="tandemDuplications", hist=TRUE)
head(delSizes, n=15)
@
See Fig.2, Fig.3, Fig.4 and Fig.5 to see the estimated distribution based on the SVs in the DGV. When using these default values, it is recommended to simulate SVs that do not differ too much in size (aroung 500bp-10kb).
\begin{figure}[p]
\begin{center}
  \includegraphics[height=9cm, width=9cm]{RSVSim-sizesExample3}
  \caption{Distribution of 10.000 deletion sizes based on deletions from the Database of Genomic Variants.}
\end{center}
\end{figure}
\begin{figure}[p]
\begin{center}
  \includegraphics[height=9cm, width=9cm]{RSVSim-sizesExample4}
  \caption{Distribution of 10.000 insertion sizes based on insertions from the Database of Genomic Variants.}
\end{center}
\end{figure}
\begin{figure}[p]
\begin{center}
  \includegraphics[height=9cm, width=9cm]{RSVSim-sizesExample4}
  \caption{Distribution of 10.000 inversion sizes based on inversions from the Database of Genomic Variants.}
\end{center}
\end{figure}
\begin{figure}[p]
\begin{center}
  \includegraphics[height=9cm, width=9cm]{RSVSim-sizesExample5}
  \caption{Distribution of 10.000 tandem duplication sizes based on tandem duplications from the Database of Genomic Variants.}
\end{center}
\end{figure}

\section{Runtime}
The runtime of \Rpackage{RSVSim} mainly depends on the number of simulated breakpoints and the size of the genome. \\
The following test case simulates 50 SVs (10 per SV type) on the complete hg19:
<<label=runtime1, eval=FALSE>>=
simulateSV(output=NA, dels=10, ins=10, inv=10, dups=10, trans=10, 
sizeDels=10000, sizeIns=10000, sizeInvs=10000, sizeDups=10000, 
repeatBias=FALSE, bpFlankSize=50, percSNPs=0.25, indelProb=0.5, maxIndelSize=10)
@
Ten repetitions of the simulation yield an average time of 6 minutes on a single Intel Xeon CPU with 2.40GHz an R version 2.15.2 (2012-10-26) including loading of the hg19 and writing of the output to disc. \\
Enabling biases for repeat regions for the same test case (i.e. \Rcode{repeatBias=TRUE}), yield an average 7 minutes. \\
For other simulations on hg19, the runtime will scale linearly with the number of SV breakpoints. \\
Note, that the one-time, initial download of the repeat coordinates for hg19 from the UCSC browser may take up to 45 minutes. Alternatively, providing a RepeatMasker output file is much quicker (see section 3 for more details).


\begin{thebibliography}{}

\bibitem[Chen {\it et al}., 2008]{svformation4} Chen W. {\it et al} (2008) Mapping translocation breakpoints by next-generation sequencing, {\it Genome Res}, {\bf 18(7)}, 1143-1149.
\bibitem[Huang {\it et al}., 2011]{art} Huang W. {\it et al} (2011) ART: a next-generation sequencing read simulator, {\it Bioinformatics}, {\bf 28 (4)}, 593-594.
\bibitem[Hu {\it et al}., 2012]{pirs} Hu X. {\it et al} (2012) pIRS: Profile-based Illumina pair-end reads simulator, {\it Bioinformatics}, {\bf 28(11)}, 1533-1535.
\bibitem[Iafrate {\it et al}., 2004]{dgv} Iafrate A.J. {\it et al} (2004) Detection of large-scale variation in the human genome, {\it Nat Genet.}, {\bf 36(9)}, 949-951.
\bibitem[Lam {\it et al}., 2010]{svformation1} Lam H.Y. {\it et al} (2010) Nucleotide-resolution analysis of structural variants using BreakSeq and a breakpoint library, {\it Nat Biotechnol}, {\bf 28(1)}, 47-55.
\bibitem[Mills {\it et al}., 2011]{1000genomes} Mills R.E. {\it et al} (2011) Mapping copy number variation by population-scale genome sequencing, {\it Nature}, {\bf 470(7332)}, 59-65.
\bibitem[Ou {\it et al}., 2011]{svformation3} Ou Z. {\it et~al} (2011) Observation and prediction of recurrent human translocations mediated by NAHR between nonhomologous chromosomes, {\it Genome Res}, {\bf 21(1)}, 33-46.
\bibitem[Pang {\it et al}., 2013]{svformation2} Pang A.W. {\it et al} (2013) Mechanisms of Formation of Structural Variation in a Fully Sequenced Human Genome, {\it Hum Mutat}, {\bf 34(2)}, 345-354.
\bibitem[Smit {\it et al}., 1996-2010]{repeatmasker} Smit A. {\it et al} (1996-2010) RepeatMasker Open-3.0., <http://www.repeatmasker.org>.


\end{thebibliography}


\section{Session Information}
<<sessionInfo, echo=FALSE>>=
sessionInfo()
@

\end{document}

\name{estimateSVSizes}

\alias{estimateSVSizes}
\alias{estimateSVSizes,numeric,missing,ANY,ANY,character-method}
\alias{estimateSVSizes,numeric,missing,ANY,ANY,missing-method}
\alias{estimateSVSizes,numeric,numeric,ANY,ANY,missing-method}


\title{Draw random structural variation sizes from a beta distribution}

\description{\pkg{RSVSim} can implement structural variations (SVs) of specific sizes. \command{estimateSVSizes} draws random values for SV sizes from a beta distribution. It can fit the distribution according to given SV sizes or default values.}

\usage{estimateSVSizes(n, svSizes, minSize, maxSize, default, hist=TRUE)}

\arguments{
 \item{n}{The number of SVs to simulate}
 \item{svSizes}{A numeric vector with SV sizes to calculate the parameters for the beta distribution}
 \item{minSize}{The minimum returned SV size}
 \item{maxSize}{The maximum returned SV size}
 \item{hist}{TRUE or FALSE to show a histogram of the SV sizes (or not)}
 \item{default}{Setting this to "deletions", "insertions", "inversions" or "tandemDuplications" loads default shape parameters for the beta distribution for these SV types (see details below)}
}

\details{
  \itemize{
    \item \code{minSize} and \code{maxSize} are optional and taken from the given set of \code{svSizes} if omitted
    \item The default shape parameters for deletions, insertions, inversions and tandem duplications were estimated from sequencing studies in the Database of Genomic Variants release 2012-03-29. In total, 1.129 deletions, 490 insertions, 202 inversions and 145 tandem duplications between 500bp and 10kb were used to estimate the shape of the distribution. 
  }
}

\value{A numeric vector with beta distributed values between \code{minSize} and \code{maxSize}.}

\references{Database of Genomic Variants: \url{http://dgvbeta.tcag.ca/dgv/app/home?ref=NCBI36/hg18}}

\note{
  \itemize{
    \item It is intended to run this function separately for every SV type and then provide the output to the respective size argument of \code{\link{simulateSV}}
    \item It is recommended to use a \code{minSize} and \code{maxSize} that is consistent with the minimum/maximum values in \code{svSizes}.
    \item When using default shape parameters for the beta distribution, it works best to simulate SVs that do not differ too much in size (aroung 500bp-10kb).
  }
}

\author{Christoph Bartenhagen}

\examples{
  ## estimate sizes for 20 SVs from a given set of values:
  svSizes = c(10,20,30,40,60,80,100,150,200,250,300,400,500,750,1000)
  estimateSVSizes(n=20, svSizes=svSizes, hist=FALSE) 

  ## when using the default shape parameters for deletions:
  estimateSVSizes(n=20, minSize=500, maxSize=10000, hist=FALSE, default="deletions")
}

\name{simulateSV}

\alias{simulateSV}
\alias{simulateSV,ANY}
\alias{simulateSV,ANY-method}

\title{Structural Variant Simulation}

\description{A tool for simulating deletions, insertions, inversions, tandem duplications and translocations in any genome available as FASTA-file or BSgenome data package. Structural variations (SVs) are placed within the given genome, or only a subset of it, in a random, non-overlapping manner or at given genomic coordinates. SV breakpoints can be positioned uniformly or with a bias towards repeat regions and regions of high homology.}

\usage{simulateSV(output=".", genome, chrs, dels=0, ins=0, invs=0, dups=0, trans=0, size, sizeDels=10, sizeIns=10, sizeInvs=10, sizeDups=10, regionsDels, regionsIns, regionsInvs, regionsDups, regionsTrans, maxDups=10, percCopiedIns=0, percBalancedTrans=1, bpFlankSize=20, percSNPs=0, indelProb=0, maxIndelSize=10, repeatBias=FALSE, weightsMechanisms, weightsRepeats, repeatMaskerFile, bpSeqSize=100, random=TRUE, seed, verbose=TRUE)}

\arguments{
  \item{output}{Output directory for the rearranged genome and SV lists; turn this off by passing \code{NA} (default: current directory)}
  \item{genome}{The genome as \code{DNAStringSet} or as filename pointing to a FASTA-file containing the genome sequence}
  \item{chrs}{Restrict simulation to certain chromosomes only (default: all chromosomes available)}
  \item{dels}{Number of deletions}
  \item{ins}{Number of insertions}
  \item{invs}{Number of inversions}
  \item{dups}{Number of tandem duplications}
  \item{trans}{Number of translocations}
  \item{size}{Size of SVs in bp (a single numeric value); a quick way to set a size, which is applied to all simulated SVs}
  \item{sizeDels}{Size of deletions: Either a single number for all deletions or a vector with a length for every single deletion}
  \item{sizeIns}{Size of insertions: Either a single number for all insertions or a vector with a length for every single insertion}
  \item{sizeInvs}{Size of inversions: Either a single number for all inversions or a vector with a length for every single inversion}
  \item{sizeDups}{Size of tandem duplications: Either a single number for all tandem duplications or a vector with a length for every single tandem duplication}
  \item{regionsDels}{\code{GRanges} object with regions within the genome where to place the deletions}
  \item{regionsIns}{\code{GRanges} object with regions within the genome where to place the Insertions}
  \item{regionsInvs}{\code{GRanges} object with regions within the genome where to place the inversions}
  \item{regionsDups}{\code{GRanges} object with regions within the genome where to place the tandem duplications}
  \item{regionsTrans}{\code{GRanges} object with regions within the genome where to place the translocations}
  \item{maxDups}{Maximum number of repeats for tandem duplications}
  \item{percCopiedIns}{Percentage of copy-and-paste-like insertions (default: 0, i.e. no inserted sequences are duplicated)}
  \item{percBalancedTrans}{Percentage of balanced translocations (default: 1, i.e. all translocations are balanced)}
  \item{bpFlankSize}{Size of the each breakpoint's flanking regions, which may contain additional SNPs and/or indels}
  \item{percSNPs}{Percentage of SNPs within a breakpoint's flanking region}
  \item{indelProb}{Probability for an indel within a breakpoint's flanking region}
  \item{maxIndelSize}{Maximum size of an indel}
  \item{repeatBias}{If TRUE, the breakpoint positioning is biased towards repeat regions instead of a uniform distribution; turned off by default (see details below)}
  \item{weightsMechanisms}{Weights for SV formation mechanisms (see details and examples below)}
  \item{weightsRepeats}{Weights for repeat regions (see details and examples below)}
  \item{repeatMaskerFile}{Filename of a RepeatMasker output file}
  \item{bpSeqSize}{Length of the breakpoint sequences in the output}
  \item{random}{If TRUE, the SVs will be placed randomly within the genome or the given regions; otherwise, the given regions will be used as SV coordinates (\code{random} can also be a vector of five elements with TRUE/FALSE for every SV in the following order: deletions, insertions, inversions, duplications, translocations)}
  \item{seed}{Fixed seed for generation of random SV positions}
  \item{verbose}{If TRUE, some messages about the progress of the simulation will be printed into the R console}
}

\details{
  About the supported SV types:
  \itemize{
    \item Deletions: A segment is cut out from the genome.
    \item Insertions: A segment is cut or copied (see parameter \code{percCopiedIns}) from one chromosome A and inserted into another chromosome B.
    \item Inversions: A segment is cut out from one chromosome and its reverse complement is inserted at the same place without loss or a shift of sequence.
    \item Tandem duplication: A segment is duplicated one after the other at most \code{maxDups} times.
    \item Translocation: A segment from the 5' or 3' end of one chromosome A is exchanged with the 5' or 3' end of another chromosome B. If it is not balanced (see parameter \code{percBalancedTrans}), the segment from chromosome B will be lost, what results in a duplicated sequence from chromosome A. Segments translocated between two different ends (5'<->3' or 3'<->5') are always inverted.
  }
  About SV sizes and predefined regions:
  \itemize{
    \item The region arguments (\code{regionsDels},\code{regionsIns}, \code{regionsInvs},\code{regionsDups},\code{regionsTrans}) can be used in two ways: 1. as subsets of the genome where to place the SVs randomly or 2. as coordinates of SVs that shall be implemented at these exact positions. The latter can be useful to implement a predefined set of previously detected or known SVs. Set the parameter \code{random} to FALSE accordingly. In this case, the rownames of the region arguments will be used to name the SVs in the output.
    \item In case of insertions and translocations, where two genomic regions are involved, add columns "chrB" and "startB" for insertions and "chrB", "startB", "endB" for translocations to the \code{GRanges} objects in \code{regionsTrans} and \code{regionsIns}, respectively.
    \item It is recommended to set the size of an SV individually for every deletion, insertion, inversion or tandem duplication. See the function \command{estimateSVSizes} to estimate beta-distributed sizes from a training set of SVs (defaults for deletions, insertions, inversions and tandem duplications are available). Using the argument \code{size} to set the size for all SVs overrides all other size arguments.
    \item There is no size argument for translocations. After random generation of the breakpoint, the translocation spans the chromosome until the closest of both chromosome ends.
  }
  About biases towards SV formation mechanisms and repeat regions:
  \itemize{
    \item When using the default genome hg19 and setting \code{repeatBias=TRUE}, RSVSim simulates a bias of breakpoint positioning towards certain kinds of repeat regions and regions of high homology. If \code{repeatBias=FALSE} (the default), the breakpoints will be placed uniformly across the whole genome.
    \item This is done in two steps: 1. Weighting SV formation mechanisms (here: NAHR, NHR, VNTR, TEI, Other) for each SV type. 2. Weighting each SV formation mechanism for each kind of repeat (supported: LINE/L1, LINE/L2, SINE/Alu, SINE/MIR, segmental duplications (SD), tandem repeats (TR), Random). The default weights were chosen from studies with SVs >1.000bp by Mills et al., Pang et al., Ou et al. and Hu et al. It is possible to change these weights by using the arguments weightsMechanisms and weightsRepeats, which need to have a certain data.frame structure (see vignette and examples below for details).
    \item For the mechanism NAHR, both breakpoints will lie within a repeat region, while for NHR, VNTR, TEI and Other, the repeat must make up for at least 75\% of the SV region.
    \item This feature requires the coordinates of repeat regions for hg19. This can be handled in two ways: 1. When using this feature the first time, RSVSim downloads the coordinates once automatically from the UCSC Browser's RepeatMasker track (which may take up to 45 Minutes!) 2. The user may specify the filename of a RepeatMasker output file downloaded from their homepage: http://www.repeatmasker.org/species/homSap.html (e.g. hg19.fa.out.gz). In both cases, RSVSim saves the coordinates as RData object to the RSVSim installation directory for a faster access in the future.
    \item This feature is turned off automatically, when the user specifies his own genome. Then, breakpoints will be placed uniformly across the genome. 
  }
  About additional breakpoint mutations:
  \itemize{
    \item RSVSim allows to randomly generate additional SNPs and indels within the flanking regions of each breakpoint.
    \item By default, this feature is turned off. It is recommended to set the four arguments bpFlankSize, percSNPs, indelProb and maxIndelSize to use this feature.
    \item Each flanking region may only contain one indel, while insertions and deletions are equally likely. SNPs can affect 0-100\% of the region.
  }
  Misc:
  \itemize{
    \item By default, the human genome (hg19) will be used, which requires the package \pkg{BSgenome.Hsapiens.UCSC.hg19}.
    \item SVs will not be placed within unannotated regions or assembly gaps denoted by the letter "N". These regions are detected and filtered automatically.
  }
}

\value{
  The rerranged genome as a \code{DNAStringSet}. Its \code{metadata} slot contains a named list of \code{data.frames} with information about the simulated SVs:
  \item{deletions}{The coordinates of the implemented deletions and the breakpoint sequence}
  \item{insertions}{The coordinates of the origin (chrA) and destination (chrB) of the inserted sequence and the breakpoints sequences at both ends (5' and 3'). If the sequence is cut out from the original chromosome A, the sequence of this breakpoint is given as well.}
  \item{inversions}{The coordinates of the implemented inversions and the breakpoint sequences at both ends (5' and 3')}
  \item{tandemDuplications}{The coordinates of the duplicated sequence and the breakpoint sequence}
  \item{translocations}{The coordinates of the translocated sequences and the two breakpoint sequences (if balanced)}
  The coordinates in the tables refer to the "normal" reference genome. \cr
  All the list items can also be written to the specified output directory (which is the current directory by default). The genome will be saved in FASTA format and the SVs \code{data.frames} as CSV tables.
}

\references{
  Chen W. et al., Mapping translocation breakpoints by next-generation sequencing, 2008, Genome Res, 18(7), 1143-1149.
  Lam H.Y. et al., Nucleotide-resolution analysis of structural variants using BreakSeq and a breakpoint library, 2010, Nat Biotechnol, 28(1), 47-55.
  Mills R.E. et al., Mapping copy number variation by population-scale genome sequencing, 2011, Nature, 470(7332), 59-65
  Ou Z. et al., Observation and prediction of recurrent human translocations mediated by NAHR between nonhomologous chromosomes, 2011, Genome Res, 21(1), 33-46.
  Pang A.W. et al., Mechanisms of Formation of Structural Variation in a Fully Sequenced Human Genome, 2013, Hum Mutat, 34(2), 345-354.
  Smit et al., RepeatMasker Open-3.0., 1996-2010, <http://www.repeatmasker.org>
}
\author{Christoph Bartenhagen}

\seealso{\code{\link{estimateSVSizes}}}

\examples{

## Toy example: Artificial genome with two chromosomes
genome = DNAStringSet(c("AAAAAAAAAAAAAAAAAAAATTTTTTTTTTTTTTTTTTTT", "GGGGGGGGGGGGGGGGGGGGCCCCCCCCCCCCCCCCCCCC"))
names(genome) = c("chr1","chr2")

## Three deletions of sizes 10bp each
sim = simulateSV(output=NA, genome=genome, dels=3, sizeDels=10, bpSeqSize=10)
sim
metadata(sim)

## Three insertions of 5bp each; all cut-and-paste-like (default)
sim = simulateSV(output=NA, genome=genome, ins=3, sizeIns=5, bpSeqSize=10)
sim
metadata(sim)
## Three insertions of 5bp each; all copy-and-paste-like (note the parameter \code{percCopiedIns})
sim = simulateSV(output=NA, genome=genome, ins=3, sizeIns=5, percCopiedIns=1, bpSeqSize=10)
sim
metadata(sim)

## Three inversions of sizes 2bp, 4bp and 6bp
sim = simulateSV(output=NA, genome=genome, invs=3, sizeInvs=c(2,4,6), bpSeqSize=10)
sim
metadata(sim)

## A tandem duplication of 4bp with at most ten duplications
## The duplication shall be placed somewhere within chr4:18-40
library(GenomicRanges)
region = GRanges(IRanges(10,30),seqnames="chr1")
sim = simulateSV(output=NA, genome=genome, dups=1, sizeDups=4, regionsDups=region, maxDups=10, bpSeqSize=10)
sim
metadata(sim)

## A balanced translocation (default)
sim = simulateSV(output=NA, genome=genome,trans=1, bpSeqSize=6, seed=246)
sim
metadata(sim)
## Another translocation, but unbalanced (note the parameter \code{percBalancedTrans})
sim = simulateSV(output=NA, genome=genome, trans=1, percBalancedTrans=0, bpSeqSize=6)
sim
metadata(sim)

## Simulate all four SV types at once:
## 2 deletions (5bp), 2 insertions (5bp),2 inversions (3bp), 1 tandem duplication (4bp), 1 translocations
sim = simulateSV(output=NA, genome=genome, dels=2, ins=2, invs=2, dups=1, trans=1, sizeDels=5, sizeIns=5, sizeInvs=3, sizeDups=4, maxDups=3, percCopiedIns=0.5, bpSeqSize=10)
sim
metadata(sim)

## Avoid random generation of coordinates and implement a given deletion of 10bp on chr2:16-25
knownDeletion = GRanges(IRanges(16,25), seqnames="chr2")
names(knownDeletion) = "myDeletion"
knownDeletion
sim = simulateSV(output=NA, genome=genome, regionsDels=knownDeletion, bpSeqSize=10, random=FALSE)
sim
metadata(sim)

## Avoid random generation of coordinates and implement a given insertion from chr1:16:25 at chr2:26
knownInsertion = GRanges(IRanges(16,25), seqnames="chr1", chrB="chr2", startB=26)
names(knownInsertion) = "myInsertion"
knownInsertion
sim = simulateSV(output=NA, genome=genome, regionsIns=knownInsertion, bpSeqSize=10, random=FALSE)
sim
metadata(sim)

## This example simulates a translocation t(9;22) leading to the BCR-ABL fusion gene.
## It uses simple breakpoints within 9q34.1 and 22q11.2 for demonstration
## Take care to add coordinates of both chromosomes to the GRanges object:
trans_BCR_ABL = GRanges(IRanges(133000000,141213431), seqnames="chr9", chrB="chr22", startB=23000000, endB=51304566, reciprocal=TRUE)
names(trans_BCR_ABL) = "BCR_ABL"
trans_BCR_ABL
## This example requires the \pkg{BSgenome.Hsapiens.UCSC.hg19} which is used by default (hence, no genome argument)
\dontrun{sim = simulateSV(output=NA, chrs=c("chr9", "chr22"), regionsTrans=trans_BCR_ABL, bpSeqSize=30, random=FALSE)}


## Add additional SNPs and indels at the flanking regions of each SV breakpoint:
## One deletion and 10\% SNPs, 100\% indel probability within 10bp up-/downstream of the breakpoint
sim = simulateSV(output=NA, genome=genome, dels=1, sizeDels=5, bpFlankSize=10, percSNPs=0.25, indelProb=1, maxIndelSize=3, bpSeqSize=10);
sim
metadata(sim)

## Setting the weights for SV formation mechanism and repeat biases demands a given data.frame structure
## The following weights are the default settings
## Please make sure your data.frames have the same row and column names, when setting your own weights
data(weightsMechanisms, package="RSVSim")
weightsMechanisms
data(weightsRepeats, package="RSVSim")
weightsRepeats
## The weights take effect, when no genome argument has been specified (i.e. the default genome hg19 will be used) and the argument repeatBias has been set to TRUE
\dontrun{sim = simulateSV(output=NA, dels=10, invs=10, ins=10, dups=10, trans=10, repeatBias = TRUE, weightsMechanisms=weightsMechanisms, weightsRepeats=weightsRepeats)}
## If weightsMechanisms and weightsRepeats were omitted, RSVSim loads the default weights automatically (see details section above for more info)
\dontrun{sim = simulateSV(output=NA, dels=10, invs=10, ins=10, dups=10, trans=10, repeatBias = TRUE)}

}

\keyword{datagen}

\name{compareSV}

\alias{compareSV}
\alias{compareSV,character,character-method}
\alias{compareSV,character,data.frame-method}
\alias{compareSV,data.frame,data.frame-method}

\title{Compare the simulation with a set of SVs}

\description{
A typical use case of structural variant (SV) simulation with \code{\link{simulateSV}} is the evaluation of SV detection algorithms. The function \code{compareSV} looks for breakpoint overlaps between the output of the simulation (ground truth) and the output of an SV detection program and computes the sensitivity and precision. There is currently no common standard format for SVs. Because the main information about SVs is their position in the genome and, sometimes, the breakpoint sequence (depending on the SV detection algorithm), \code{compareSV} expects the SV detections in a simple BED- or BEDPE format.

Note that \code{compareSV} requires the \pkg{pwalign} package.
}

\usage{compareSV(querySVs, simSVs, tol=200)}

\arguments{
  \item{querySVs}{The set detected of SVs. Either a filename for a table of SVs on disk or a \code{data.frame}. The table has to be in BED- or BEDPE-format (see details below). The \code{querySVs} may only contain SVs of one type and not a mixture of several kinds of SVs.}
  \item{simSVs}{The set of simulated SVs as returned by the function \code{\link{simulateSV}}. It can be either a filename for a table of SVs on disk or a \code{data.frame}.}
  \item{tol}{The tolerance in bp, when comparing the (approximate) positions in \code{querySVs} with the exact, simulated breakpoints \code{simSVs}. Positions in \code{querySVs} may only differ by at most \code{tol} base pairs from the simulated breakpoints.}
}

\details{
  An overlap is defined as the overlap between the breakpoints / breakpoint regions up to the given tolerance in bp. Overlap does not mean the whole affected region between the start and end of the SV. \cr
  The comparison has to be done for each type of SV separately.
  It is required to use the returned tables from \code{\link{simulateSV}} for the argument \code{simSVs}. For \code{querySVs}, the tables have to be in BED- or BEDPE-format, a simple tab-separated table with genome coordinates and an optional column with the breakpoint sequence (bpSeq):
  \itemize{
    \item Deletions: (1) BED with columns chr, start, end (, bpSeq) for exact breakpoints or (2) BEDPE with columns chr, start1, end1, chr, start2, end2 (, bpSeq) for approximate breakpoint regions
    \item Insertions: BEDPE with columns chrA, startA, endA, chrB, startB, endB (, bpSeq). Typically, a complete insertion is reported in two rows, one for the breakpoint at the 5' and one at the 3' end
    \item Inversions: (1) BED with columns chr, start, end (, bpSeq1, bpSeq2) or (2) BEDPE with columns chr, start1, end1, chr, start2, end2 (, bpSeq1, bpSeq2). Inversions, the larger ones, typically have two breakpoint sequences (one for the 5' and on for the 3' end)
    \item Tandem duplications: (1) BED with columns chr, start, end (, bpSeq) or (2) BEDPE with columns chr, start1, end1, chr, start2, end2 (, bpSeq)
    \item Translocations: BEDPE with columns chrA, startA, endA, chrB, startB, endB (, bpSeq1, bpSeq2)
  }
  The BEDPE-format is required for insertions and translocations, since they involve two regions on the genome. For other SVs, the BEDPE allows to specify approximate regions for each breakpoint. For example a deletion "chr:start-end" can be given as BED-file with columns chr, start, end or (a little redundant) as BEDPE-file with columns chr, start, start, chr, end, end or (with some tolerance) like chr, start-tol, start+tol, chr, end-tol, end+tol. The tolerance can also be regulated by the function argument \code{tol}.
}

\value{
The table of simulated SVs, as given in the function argument \code{querySVs}, but with additional columns for the overlapping region in \code{querySVs} and the percentage overlap between the breakpoint sequences (if they were provided as a column in \code{querySVs}). \cr
Furthermore, the function prints the sensitivity and precision in the R console.
}

\references{More information about the BED-format can be found on the BEDTools homepage: \url{http://code.google.com/p/bedtools}}

\author{Christoph Bartenhagen}

\seealso{\code{\link{simulateSV}}}

\examples{

  ## Toy example: Artificial genome with two chromosomes
  genome = DNAStringSet(c("AAAAAAAAAAAAAAAAAAAATTTTTTTTTTTTTTTTTTTT", "GGGGGGGGGGGGGGGGGGGGCCCCCCCCCCCCCCCCCCCC"))
  names(genome) = c("chr1","chr2")

  #######################
  ## Example 1: Deletions
  ## Simulation of 5 deletions of 5bp each
  sim = simulateSV(output=NA, genome=genome, dels=5, sizeDels=5, bpSeqSize=10, seed=246)
  simSVs = metadata(sim)$deletions

  ## An SV detection in BED format may look like this:
  ## Four of five deletions were detected; two with exact and two with an approximate breakpoint
  ## Two additional deletions were detected, which were not part of the simulation
  ## The column with the breakpoint sequence is optional, the column names not important (BED-files have no header)
  querySVs = data.frame(
    chr=c("chr1","chr1","chr1","chr2","chr2","chr2"), 
    start=c(4,12,20,10,21,34), 
    end=c(8,16,28,14,31,38), 
    bpSeq=c("AAAAAAAAAA", "AAAAAAAAAT", "AAAATTTTTT", "GGGGGGGGGG", "GGGGGGGCCC", "CCCCCCCCCC")
  )
  
  ## Compare the SVs with 0bp tolerance:
  ## Only the two exact detections have an overlap
  simSVs_overlap1 = compareSV(querySVs, simSVs, tol=0)
  simSVs_overlap1

  ## Increasing the breakpoint tolerance to +/- 3bp :
  ## Now, the overlap also includes the more imprecise detections
  ## And the sensitivity and precision are better
  ## Note that for deletion2, the breakpoint sequence matches only by 50%
  simSVs_overlap2 = compareSV(querySVs, simSVs, tol=3)
  simSVs_overlap2

  ############################
  ## Example 2: Translocations
  ## Simulation of 2 translocations (only one of them is balanced):
  sim = simulateSV(output=NA, genome=genome, trans=2, percBalancedTrans=0.5, bpSeqSize=10, seed=246)
  simSVs = metadata(sim)$translocations
  
  ## Detected translocations have to be given in BEDPE-format (i.e. at least six columns with chr,start,end for breakpoints on both chromosomes)
  ## In this example, the breakpoints were approximated up to 1 or 2bp
  ## Optional breakpoint sequences are missing
  querySVs = data.frame(
    chr=c("chr2", "chr1", "chr2"), 
    start1=c(25,3,9), 
    end1=c(29,7,12), 
    chr2=c("chr1","chr2","chr1"),
    start2=c(22,10,3),
    end2=c(25,13,4)
  )

  simSVs_overlap = compareSV(querySVs, simSVs, tol=0)
  simSVs_overlap

}

\name{segDups}
\alias{segDups}

\docType{data}

\title{
  Segmental duplications
}

\description{
  A list with coordinates of segmental duplications detected by RepeatMasker.
  It is loaded automatically when the repeat bias feature has been turned on (\code{repeatBias=TRUE} in function \code{simulateSV}).
  (But this dataset is intended for internal use; no need to handle it manually.)
}

\usage{
  data("segmentalDuplications")
}

\format{
    Formal class 'GRanges'
}

\source{
  Downloaded from the UCSC Browser's RepeatMasker track.
  Meyer et al., The UCSC Genome Browser database: extensions and updates 2013, 2013, Nucleic Acids Res, 41(Database issue), 64-69.
  Smit et al., RepeatMasker Open-3.0., 1996-2010, <http://www.repeatmasker.org>.
}

\examples{
  data("segmentalDuplications")
  segDups
}

\keyword{datasets}

\name{weightsMechanisms}
\alias{weightsMechanisms}

\docType{data}

\title{
  Weights for SV formation mechanisms
}

\description{
  The default weights of all supported SV formation mechanisms for all SVs.
  It is loaded automatically when the repeat bias feature has been turned on (\code{repeatBias=TRUE} in function \code{simulateSV}).
  (But this dataset is intended for internal use; no need to handle it manually.)
}

\usage{
  data("weightsMechanisms")
}

\format{
    Formal class 'data.frame'
}


\examples{
  data("weightsMechanisms")
  weightsMechanisms
}

\keyword{datasets}
